startmacro l:nfft[256] l:nppt[8] d:foff[.124] d:ratio[1.0] l:gain[0] s:flags[]

res size nfft*1200
res sizf nfft*128
res sizf nfft*1000
res sizg sizf+(12*nfft)
res mfft 40

info "Creating test input file"
if /sin then
 wave testin shape=sin form=sf amp=15e3 freq=.1255 elem=size
else
 wave testin shape=lrs form=sf amp=15e3 elem=size
 firwind tmpfir STOPBAND BH92 1k .075 .175 .5
 fdfilter testin tmpfir testin
 fdfilter testin tmpfir testin
 fdfilter testin tmpfir testin
 wave testins shape=sin form=sf amp=1e3 freq=.125 elem=size
 fcalc testin testin testins +
endif
reformat testin testoutm "CI"
calc dfreq 1/file(testoutm).xd nfft /
calc sfreq dfreq*0 foff +
calc orate dfreq ratio *

info "Running all ^nfft channels"
timer set
icebot/core=j testoutm(0:sizf) testfftj nfft sfreq dfreq orate gain /nppt=nppt /flags=flags
icebot/core=v testoutm(0:sizg) testfftv nfft sfreq dfreq orate gain /nppt=nppt /flags=flags
timer elapse

fsvi/mag=2 testfftj testpsdj
fsvi/mag=2 testfftv testpsdv
plot/bg/db testpsdj|testpsdv z1=-6
if /nochan istrue stop

info "Running only ^mfft channels"
timer set
icebot/core=j testoutm testchnj mfft sfreq dfreq orate gain /nppt=nppt /flags=flags
icebot/core=v testoutm testchnv mfft sfreq dfreq orate gain /nppt=nppt /flags=flags
timer elapse

switch "CHN" chni get 0

thin testchnj testchnij 0 -0 1 chni chni+1 1
thin testchnv testchniv 0 -0 1 chni chni+1 1
header testchnij xd=file(testchnj).yd xs=0 xu=1 fs=0 
header testchniv xd=file(testchnv).yd xs=0 xu=1 fs=0
spectra testchnij testpsdij 1k
spectra testchniv testpsdiv 1k
plot/db testpsdij|testpsdiv

endmacro
