!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Test example for a generic ICE Library Core
! s:name Name of core (User,Noop)
! s:impl List of implementation letters (J,C,V,I ...)
! t:cfg  Table of parameters with names like P0, P1, ... P<N>
!
startmacro cs:name s:cores t:cfg[{}]

switch "FORM" form get "CI"
switch "SHAPE" shape get "SIN"
set amp 20e3
if "B" subs form set amp 100
switch "AMP" amp get amp
switch "LENGTH" len get 128k

! generate a test input waveform
wave testin shape=shape form=form amp=amp elem=len

set files "testin"
! run through list of core implementations
while cores neqs ""
  sedit cores core range 0 0 locase
  say "Running core=^name impl=^core form=^form"
  icecore/core=^core/cfg=cfg testin testout^core name
  sedit cores cores range 1
  set files "^files|testout^core"
endwhile

! plot the results
plot ^files x1=0 x2=1000

endmacro
