startmacro l:nfft[1K] s:win[HANN] l:navg[8] l:gain[5] s:aflags[]

calc l:size nfft*128 16k max

info "Creating test input file"
if /sin then
 wave testin0 shape=white form=cf amp=5e3 elem=size/4 
 wave testin1 shape=sin form=cf amp=5e3 elem=nfft freq=.1
 wave testin2 shape=sin form=cf amp=5e3 elem=nfft freq=.2
 wave testin3 shape=sin form=cf amp=5e3 elem=nfft freq=.3
 noop testin1 testin
 mergefile testin2 testin
 mergefile testin3 testin
 mergefile testin0 testin
 mergefile testin testin
 mergefile testin testin
 mergefile testin testin
else
 wave testin shape=lrs form=sf amp=15e3 elem=size
 firwind tmpfir STOPBAND BH92 1k .075 .175 .5
 fdfilter testin tmpfir testin
 fdfilter testin tmpfir testin
 fdfilter testin tmpfir testin
 wave testins shape=sin form=sf amp=1e3 freq=.125 elem=size
 fcalc testin testin testins + 
endif
reformat testin testoutm "CI"
reformat testin testouts "SI"

timer set
icefft/core=j testoutm testfftj nfft win 0 navg /shift=gain /flags=mag|^aflags
icefft/core=c testoutm testfftc nfft win 0 navg /shift=gain /flags=mag|^aflags
icefft/core=v testoutm testfftv nfft win 0 navg /shift=gain /flags=mag|^aflags
icefft/core=v testoutm testfftw nfft win 0 1    /shift=gain 
icefft/core=v testouts testfftx nfft win 0 1    /shift=gain+1 
timer elapse

fsvi testfftj testpsdj
fsvi testfftc testpsdc
fsvi testfftv testpsdv
fsvi testfftw testpsdw /mag
fsvi testfftx testpsdx /mag

plot/db2 testpsdj|testpsdc|testpsdv|testpsdw|testpsdx y1=-40

endmacro
