startmacro s:sig[FIR] n:taps[63] n:dec[1]

if sig eqss "PCIE" then
  ramp tin form=si elem=2m
  vcore tin tout sig
  stop
elseif sig eqss "JVM" then
  ramp tin form=si elem=2m
  vcore tin tout sig /jf=nxm.ice.dat.icev5m_jvm_def
  stop
elseif sig eqss "IOM" or sig eqss "PPC" or sig eqss "RAM" then
  ramp tin form=si elem=64K
  vcore tin tout sig
  stop
endif

res nfft 4k
switch "DEMOD" lut   get "AM"
switch "IFORM" iform get "SI"
switch "OFORM" oform get iform
switch "SHAPE" shape get "LRS"
switch "SFREQ" freq get .05
switch "LEN"   len  get 64k
if "B" subs iform
  res amp 100
elseif /h or /hh then
  res amp 15e3
else
  res amp 25e3
endif
switch "AMP" l:amp get amp

! generate test waveform
if sig eqs "DMOD" and lut eqs "AM" then
  waveform tcar form=cf shape=sin freq=.11 amp=amp elem=len
  waveform tmod form=sf shape=shape freq=freq amp=1/3 elem=len
  fcalc tin{form=ci} tcar tmod 2/3 + *
else
  waveform tin form=iform shape=shape freq=freq amp=amp elem=len
  if /noise gt 0 then
    waveform tnoise form=iform shape=white freq=freq amp=/noise elem=len
    fcalc tcomb tin tnoise +
    noop tcomb tin
  endif
endif

! add notch to test waveform
if sig eqs "TFDD" or /notch then
 firwind jfiri STOPBAND BH92 1k .11 .14 .5  
 fdfilter tin jfiri tin 
 fdfilter tin jfiri tin 
 fdfilter tin jfiri tin 
 header tin xs=0
endif

! generate test filter
if sig eqs "TFDD" then
 firwind jfiri{form=si} LOW BH92 taps+1 .25 0 .5  /sym /scale=64k
elseif /h then
 firhlbrt jfiri{form=si} taps /scale=32k
elseif /hh then
 firhlbrt jfiri{form=si} taps /scale=32k
 thin jfiri jfiri 0 -0 2
elseif /p then
 firhlbrt jfiri{form=si} taps /scale=0
 set file(jfiri).data(31) 16K
elseif /gc then
 noop nxm.ice.dat.pfir_100 jfiri
elseif /fram then
 ramp jfiri si taps 0 1
else
 if calc(taps,2,mod) eq 0 then
   firkais jfiri{form=si} LOW .05 0 0 .5 80 taps /scale=64k
 else
   firwind jfiri{form=si} LOW BH92 taps+1 .1 0 .5  /sym /scale=64k
 endif
 if /trunc gt 0 then
   header jfiri size=/trunc
 endif
 if /extra gt 0 then
   waveform jpad shape=zero form=si elem=(/extra)
   mergefile jpad jfiri
 endif
 if /nonsym then
   ramp jram sf taps 0 2/taps
   fcalc/type=f jfiri{form=si} jfiri jram *
 endif
 statistics jfiri SUM=sum
 calc/verbose gain sum/64k 
endif

if sig eqs "TC" then
  header tin xd=1e-6
endif

! generate expected output
if sig eqs "DMOD" then
  demod tin toutf lut /lut
  noop nxm.ice.dat.LUT_^lut jfiri
else
  fdfilter tin jfiri toutf /scale=1/64k
endif

! run the core
timer set
vcore tin tout sig jfiri dec /form=oform
timer elapsed

if /flip then
  flip jfiri jfirj
  header jfirj xs=file(jfiri).xs xd=file(jfiri).xd
  noop jfirj jfiri
endif
status tout

! display results
calc ioff file(toutf).xs file(tout).xs - file(tout).xd / round 0 max
spectra tin fin nfft=nfft
spectra tout(ioff:) fout nfft=nfft
spectra toutf foutf nfft=nfft
calc nyq file(tin).nyquist
if form eqss "C" then
  header fin xs=-nyq/4
  header foutf xs=-nyq/4
elseif sig eqss "TFDD" and /tuner neqs "F" and dec gt 1 then 
  header fout xs=((nyq/4)-(nyq/dec/2))
endif
if sig eqs "NOOP" or /datalist then
  say "Tin"
  data/hex/nc=8 tin
  say "Tout"
  data/hex/nc=8 tout
  plot/db fin|foutf|fout
elseif sig eqs "TC" then
  icetc extract SDN0 tout ttcs
  data ttcs
  icetc top SDN0 tout 
else
  plot/db fin|foutf|fout
  if sig eqs "DMOD" then
    plot tout|toutf y1=-32k y2=32k /all
  endif
endif

endmacro
