#ifndef CORELIB_H_

/*
  Definitions for CORELIB runtime functions
  Author: Jeff Schoen
*/

/* CORE Jump Table */
typedef struct {
  int (*init)();
  int (*config)();
  int (*setkey)();
  int (*getkey)();
  int (*work)();
  int (*free)();
} CORE;

#ifdef __cplusplus
extern "C" {
#endif


/* C/C++ Interface */
CORE *core_alloc (const char * name);
int_4 core_config (CORE *handle, int_4 key, int_4 value);
int_4 core_open (CORE *handle);
int_4 core_process (CORE *handle, int_1 *buf1,int_4 n1, int_1 *buf2,int_4 n2);
int_4 core_close (CORE *handle);
int_4 core_setkey (CORE *handle, const char * name, void *value, int_4 size);
int_4 core_getkey (CORE *handle, const char * name, void *value, int_4 size);
int_4 core_setfmt (CORE *handle, const char * iform, const char * oform);

#ifdef __cplusplus
}
#endif

#define CORELIB_H_
#endif /* CORELIB_H_ */

