package nxm.ice.lib;

public interface IceHW {

  public final static int REG_AMDAU=0x02000044, REG_AMCSR=0x02000048, REG_AMDAR=0x02000058, REG_AMDTC=0x0200005C; 
  public final static int REG_AIMB1=0x02000060, REG_AIMB2=0x02000064, REG_AIMB3=0x02000068, REG_AIMB4=0x0200006C;
  public final static int REG_AOMB1=0x02000070, REG_AOMB2=0x02000074, REG_AOMB3=0x02000078, REG_AOMB4=0x0200007C; 
  public final static int MCSR_OMB1F=0x00010000, MCSR_IMB1F=0x00100000, MCSR_IFIFO_FULL=0x10000000, MCSR_OFIFO_EMPTY=0x08000000; 
  public final static int MCSR_RFIFO=0x00000004;
  public final static int REG_AFIFO=0x02000000; // special address map

  public final static int PM_PROC=0;
  public final static int PM_HOST=1;
  public final static int PM_HYPA=2;
  public final static int PM_HYPB=3;
  public final static int PM_CORA=4;
  public final static int PM_CORB=5;
  public final static int PM_TUNA=6;
  public final static int PM_TUNB=7;

  public final static int CORA_CTL=0x10000000, CORB_CTL=0x20000000;
  public final static int TUNA_CTL=0x40000000, TUNB_CTL=0x80000000, TUNC_CTL=0x80090000;
  public final static int GCFPGA_FREQ=(6<<2);
  public final static int GCFPGA_POFF=(7<<2);

  public final static int JTAG_BASE=0x00800000, JTAG_TMS=0x00800000, JTAG_TDI=0x00800004, JTAG_ENA=0x00800008, JTAG_STAT=0x0080000C;

  public final static int DMAC_CLOCK=0x01004000;
  public final static int DMAC_CLOCK_RMEM=0x0010;

  public final static int DMAC_CTL      =0x01008000;
  public final static int DMAC_ROUTE_RST=0x01008000;
  public final static int DMAC_ROUTE_FLG=0x01008004;
  public final static int DMAC_ROUTE_SET=0x01008008;
  public final static int DMAC_ROUTE_CLR=0x0100800C;

  public final static int ROUTE_CA2HA=0x00000001, ROUTE_CB2HA=0x00000002, ROUTE_CA2HB=0x00000004, ROUTE_CB2HB=0x00000008;
  public final static int ROUTE_HA2CA=0x00000010, ROUTE_HB2CA=0x00000020, ROUTE_HA2CB=0x00000040, ROUTE_HB2CB=0x00000080;
  public final static int ROUTE_TA2HA=0x00000100, ROUTE_CA2TA=0x00000200, ROUTE_CB2TB=0x00000400, ROUTE_TB2HB=0x00000800;
  public final static int ROUTE_HA2TA=0x00001000, ROUTE_HB2TA=0x00002000, ROUTE_HA2TB=0x00004000, ROUTE_HB2TB=0x00008000;

  public final static int ROUTE_PR2R =0x00010000, ROUTE_HP2R =0x00020000, ROUTE_HA2R =0x00040000, ROUTE_HB2R =0x00080000;
  public final static int ROUTE_CA2R =0x00100000, ROUTE_CB2R =0x00200000, ROUTE_TA2R =0x00400000, ROUTE_TB2R =0x00800000;
  public final static int ROUTE_R2PR =0x01000000, ROUTE_R2HP =0x02000000, ROUTE_R2HA =0x04000000, ROUTE_R2HB =0x08000000;
  public final static int ROUTE_R2CA =0x10000000, ROUTE_R2CB =0x20000000, ROUTE_R2TA =0x40000000, ROUTE_R2TB =0x80000000;

  public final static int ROUTF_HPFDP=0x00000010, ROUTF_HXFDP=0x00000020, ROUTF_CXFDP=0x00000040, ROUTF_TXFDP=0x00000080;
  public final static int ROUTF_TX2HX=0x00001000, ROUTF_CX2HX=0x00002000, ROUTF_TXAOB=0x00020000;

  public final static int DMA_TO=0xFD800000;
  public final static int DMA_XI=0xFD800F00;
  public final static int DMA_XO=0xFD800F40;
  public final static int DMA_TX=0xFD800F60;

  public final static int DMA_XI_HYPA=0xFD800F20;
  public final static int DMA_XI_HYPB=0xFD800F28;
  public final static int DMA_XI_TUNA=0xFD800F30;
  public final static int DMA_XI_TUNB=0xFD800F38;

  public final static int MSG=0xFD000000;
  public final static int HBT=0xFD00FFF8;

  public final static int IOC_ADDR=0x00400000;
  public final static int HYP_SHF=(PM_HYPA+24);

  public final static int IOCTL_RD=0x10000;
  public final static int IOCTL_WR=0x20000;

  public final static int ALG_INIT=0;
  public final static int ALG_OPEN=1;
  public final static int ALG_PROCESS=2;
  public final static int ALG_CLOSE=3;
  public final static int ALG_DONE=0;

  public final static int IOPT_NONE=0;
  public final static int IOPT_TUNER=4;
  public final static int IOPT_CORE=7;
  public final static int IOPT_TBANK=8;
  public final static int IOPT_MCORE=9;

  public final static int[] sbus=null;
  public final static int[] mbus=null;

  public final static int NBANK=16;

  public final static int FTT_LOC=0x480, FTT_SIZEOF=0x180;
  public final static int ALG_LOC=0x600;

  public final static int FTT_STAGES=FTT_LOC+0x0,  FTT_ACTIVE=FTT_LOC+0x4,   FTT_CSTAGE=FTT_LOC+0x8, FTT_LSTAGE=FTT_LOC+0xC;
  public final static int FTT_BUSY =FTT_LOC+0x10,  FTT_CHANTOP=FTT_LOC+0x14, FTT_BITS=FTT_LOC+0x18,  FTT_SPEED=FTT_LOC+0x1C;
  public final static int FTT_TADDR=FTT_LOC+0x20,  FTT_TB0=FTT_LOC+0x60,     FTT_TB1=FTT_LOC+0xB0,   FTT_TB2=FTT_LOC+0x100;
  public final static int FTT_OMODA=FTT_LOC+0x150, FTT_OMODB=FTT_LOC+0x154,  FTT_DCA0=FTT_LOC+0x158, FTT_DCA1=FTT_LOC+0x15C;
  public final static int FTT_TBCTL=FTT_LOC+0x160, FTT_BASE=FTT_LOC+0x164,   FTT_ADDR=FTT_LOC+0x168;

  public final static int TB_SIZEOF=80;

  public final static int TB_MCHAN=0x00,  TB_NCHAN=0x04,   TB_DEC=0x08,    TB_CPC=0x0C;
  public final static int TB_XFER=0x10,   TB_CONS=0x14,    TB_PROD=0x18,   TB_CHAN=0x1C;
  public final static int TB_INDEX=0x20,  TB_PCFG=0x24,    TB_PSTRT=0x28,  TB_PSIZE=0x2C;
  public final static int TB_PMASK=0x30,  TB_PINDX=0x34,   TB_PHINC=0x38,  TB_DPHINC=0x3C;
  public final static int TB_TPHINC=0x40, TB_TDPHINC=0x44, TB_TPHASE=0x48, TB_TDPHASE=0x4C;

  public class Message {
    public int key, node, head, addr;
    public int[] data;
  }

  public class DMAStruct {
    public int haddr, hsize, hindex, hcycle;
    public int caddr, csize, cindex, ccycle;
    public int stat,  dir,   todo,   block;
    public int cntrl, tcbp,  reg,    mcsr;
    public int enb,   enbx,  mcfg,   mcfgx;
    public int err,   miss,  iper,   multi;
    public int hxfer, hxfes, cxfer,  cxfes;
    public int cindp, hindp, cind,   hind;
    public int type,  port,  bits,   dec;
    public int rate,  gain,  fcny,   frame;
    public int master,slave, feed,   tcoff;
    public int alg,   appp,  chain,  flags;
  } 
    
  public class DMAChannel {
    public int cur,cfg;
  }

  public class TBStruct {
    public int mchan,  nchan,   dec,    cpc;
    public int xfer,   cons,    prod,   chan;
    public int index,  pcfg,    pstrt,  psize;
    public int pmask,  pindx,   phinc,  dphinc;
    public int tphinc, tdphinc, tphase, tdphase;
  }

  public class FTTStruct {
    public int stages, active, cstage, lstage;
    public int busy,   chantop, bits,   speed;
    public int[] taddr;
    public TBStruct[] tb;
    public int omoda, omodb;
    public DMAChannel dca0,dca1;
    public int tbctl,base,addr;
  }

}
