#include <jni.h>
#include <string.h>
#include "nxm_ice_lib_NetIO.h"
#include "native.h"

#include "icedefs.h"
#include "netlib.h"
#include "netlib.c"

JNIEXPORT jint JNICALL Java_nxm_ice_lib_NetIO_nioOpen (JNIEnv *env, jobject obj, jstring str, jint chans, jint flags) {
  const char *ctext; jint status;
  ctext = GetString(str);
  status = nioOpen ((char *)ctext,chans,flags);
  ReleaseString(str,ctext);
  return status;
}

JNIEXPORT jint JNICALL Java_nxm_ice_lib_NetIO_nioClose (JNIEnv *env, jobject obj,
	jint sock) {
  return nioClose (sock);
}

JNIEXPORT jlong JNICALL Java_nxm_ice_lib_NetIO_nioAlloc (JNIEnv *env, jobject obj,
	jint bytes) {
  return (jlong)(jpointer)nioAlloc (bytes);
}

JNIEXPORT jint JNICALL Java_nxm_ice_lib_NetIO_nioFree (JNIEnv *env, jobject obj,
	jlong pdata) {
  return nioFree ((void*)(jpointer)pdata);
}

JNIEXPORT jint JNICALL Java_nxm_ice_lib_NetIO_nioSend (JNIEnv *env, jobject obj,
	jint sock, jint chan, jlong vaddr, jint bytes, jint flags) {
  return nioSend (sock,chan,(void*)(jpointer)vaddr,bytes,flags);
}

JNIEXPORT jint JNICALL Java_nxm_ice_lib_NetIO_nioRecv (JNIEnv *env, jobject obj,
	jint sock, jint chan, jlong vaddr, jint bytes, jint flags) {
  return nioRecv (sock,chan,(void*)(jpointer)vaddr,bytes,flags);
}

JNIEXPORT jint JNICALL Java_nxm_ice_lib_NetIO_nioSendB (JNIEnv *env, jobject obj,
	jint sock, jint chan, jobject array, jint off, jint bytes, jint flags) {
  jbyte *bbuf = GetArray (array);
  jint status =  nioSend (sock,chan,(void*)bbuf+off,bytes,flags);
  ReleaseArray(array,bbuf);
  return status;
}

JNIEXPORT jint JNICALL Java_nxm_ice_lib_NetIO_nioRecvB (JNIEnv *env, jobject obj,
	jint sock, jint chan, jobject array, jint off, jint bytes, jint flags) {
  jbyte *bbuf = GetArray (array);
  jint status = nioRecv (sock,chan,(void*)bbuf+off,bytes,flags);
  ReleaseArray(array,bbuf);
  return status;
}

