package nxm.ice.lib;

public class QuickSort {
  private double[] out;
  private int[] ind;

  public void sort(double[] vals, int[] inds, int len) {
    out = vals;
    ind = inds;
    quicksortInds(0, len-1);
  }

  public void sort(double[] vals, int len) {
    out = vals;
    quicksort(0, len-1);
  }

  private void quicksortInds(int low, int high) {
    int i = low, j = high;
    // Get the pivot element from the middle of the list
    double pivot = out[low + (high-low)/2];

    // partition
    while (i <= j) {
      while (out[i] > pivot)
        i++;
      while (out[j] < pivot)
        j--;

      if (i <= j) {
        swapInds(i, j);
        i++;
        j--;
      }
    }
    // recursively call
    if (low < j)
      quicksortInds(low, j);
    if (i < high)
      quicksortInds(i, high);
  }

  private void quicksort(int low, int high) {
    int i = low, j = high;
    // Get the pivot element from the middle of the list
    double pivot = out[low + (high-low)/2];

    // partition
    while (i <= j) {
      while (out[i] > pivot)
        i++;
      while (out[j] < pivot)
        j--;

      if (i <= j) {
        swap(i, j);
        i++;
        j--;
      }
    }
    // recursively call
    if (low < j)
      quicksort(low, j);
    if (i < high)
      quicksort(i, high);
  }

  private void swapInds(int i, int j) {
    double tval = out[i];
    int tind = ind[i];
    out[i] = out[j];
    out[j] = tval;
    ind[i] = ind[j];
    ind[j] = tind;
  }

  private void swap(int i, int j) {
    double tval = out[i];
    out[i] = out[j];
    out[j] = tval;
  }


}
