/****************************************************************************/
/*                                                                          */
/*   partlib_common.h: you need this if you plan on using objects and        */
/*                    methods in the partlib library                         */
/*                                                                          */
/****************************************************************************/
#ifndef _IOMLIB_COMMON_H
#define _IOMLIB_COMMON_H

/*---------------------------------------------------------------------------*/
/* Includes */                              
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <math.h>   
#include <fcntl.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "icelib.h" 

#ifndef __STDFLOAT
typedef float float32_t;
typedef double float64_t;
typedef long double float128_t;
#endif

/*---------------------------------------------------------------------------*/
/* Function Prototypes */
#ifdef __cplusplus
#define EXTERN_CDEFINE extern "C"
#else
#define EXTERN_CDEFINE extern
#endif

/*---------------------------------------------------------------------------*/
/* CRC Routines */
#define CRC16POLY_LE 0x8408
#define CRC16POLY_BE 0x1021             /* CCITT 16-bit CRC        */
#define CRC32POLY_LE 0xedb88320
#define CRC32POLY_BE 0x04c11db7         /* ITU/Ethernet 32-bit CRC */

#endif /* _IOMLIB_COMMON_H */
