/****************************************************************************/
/*   GPS module interface routines                                          */
/****************************************************************************/

int_4 parseInt (char *str, int_4 off, int_4 len) {
  int_4 i,mult=1,val=0; char c;
  for (i=0; i<len; i++) {
    c = str[off+i];
    if (c>='0' && c<='9') val = val*10 + (c-'0');
    else if (c=='.') len += i+1;
    else if (c=='-') mult = -mult;
    else if (c==0) break;
  }
  return val*mult;
}

int_4 parseNext (char *str, int_4 off, int_4 item, char *s) {
  int i=off,i1,i2; char c;
  for (;item<0;) {   /* find next $ */
    c = str[++i];
    if (c==0) return -1;
    if (c=='$') item++;
  }
  for (; item>=0; item--) { /* find next entry */
    for (i1=i,i2=-1; i2<0; i++) {
      c = str[i];
      if (c==0) return -1;
      if (c==',' || c=='*') i2=i;
    }
  }
  off=i; i2-=i1;
  for (i=0; i<i2; i++) s[i]=str[i1+i]; s[i2]=0;
  return off;
}

int_4 dump_gps (PICSTRUCT *p, int_4 side, int_4 flag, real_8 *dval) {
  int_4 i,j,k,addr,year,doy,sec,vco,dbg,date=0,time=0,nos=0,lock=0,tfom=0,weight_=0;
  int_4 data[512]; char ctmp[32], *c=(char*)data;
  real_8 soy,lat,lon,alt,rtmsec,aoff,adel;

  i = pic_jpmemrd (p,side,0x1000,4);	// status
  j = pic_jpmemrd (p,side,0x1004,4);	// rtmsec of status read

  rtmsec = (j&0x1FFFF) + ((j>>28)&0xF)*.1 + ((j>>24)&0xF)*.01 + ((j>>20)&0xF)*.001;

  year = pic_jpmemrd(p,side,0xFD000000,4);
  doy  = pic_jpmemrd(p,side,0xFD000004,4);
  sec  = pic_jpmemrd(p,side,0xFD000008,4);
  dbg  = pic_jpmemrd(p,side,0xFD00000C,4);
  vco  = pic_jpmemrd(p,side,0xFD000010,4);
  lock = pic_jpmemrd(p,side,0xFD000014,4);
  /* note: average offset if scaled up by 32 */
  adel = 160000000.0+(0.0009765625*pic_jpmemrd(p,side,0xFD000018,4));
  aoff = 160000000.0+(0.0009765625*pic_jpmemrd(p,side,0xFD00001C,4));
  tfom = (lock&0xFFFF);
  weight_ = (lock&0xFE0000)>>17;
  lock = (lock&0x010000)>>16;

  soy  = (doy-1)*86400.0 + rtmsec;

  addr = (i&0x8000)? 0x2400 : 0x2000;

  for (i=0; i<256; i++,addr+=4) data[i] = pic_jpmemrd (p,side,addr,4);

  for (i=0; (i=parseNext(c,i,-1,ctmp)) >= 0; k=i) {
    if (strcmp(ctmp,"$POLYT")==0) {
      i=parseNext(c,i,0,ctmp);
      time = parseInt(ctmp,0,6);
      i=parseNext(c,i,0,ctmp);
      date = parseInt(ctmp,4,2)+2000;
      date = parseInt(ctmp,2,2)+date*100;
      date = parseInt(ctmp,0,2)+date*100;
    }
    else if (strcmp(ctmp,"$POLYP")==0) {
      i=parseNext(c,i,1,ctmp);
      lat = parseInt(ctmp,0,2) + parseInt(ctmp,2,6)/60.0e6;
      i=parseNext(c,i,0,ctmp); if (ctmp[0]=='S') lat = -lat;
      i=parseNext(c,i,0,ctmp);
      lon = parseInt(ctmp,0,3) + parseInt(ctmp,3,6)/60.0e6;
      i=parseNext(c,i,0,ctmp); if (ctmp[0]=='W') lon = -lon;
      i=parseNext(c,i,0,ctmp);
      alt = parseInt(ctmp,0,3)/1000.0;
      i=parseNext(c,i,12,ctmp);
      nos = parseInt(ctmp,0,3);
    }
    else if (strcmp(ctmp,"$POLYI")==0) break;
  }
  if (dval!=NULL) {
    dval[0] = soy;
    dval[1] = lat;
    dval[2] = lon;
    dval[3] = alt;
  } else {
    vprint("GPS len=%d nema=\n%.*s\n",k,k,c);
    print("Date=%d Time=%d NoS=%d\n",date,time,nos);
    print("SoY=%f Lat=%f Lon=%f Alt=%f\n",soy,lat,lon,alt);
    printf("JVM Year=%d DoY=%d Sec=%d VCO=%08x Dbg=%08x\n",year,doy,sec,vco,dbg);
    printf("GPS Lock: %d, TFOM: %d, weight: %d, average count: %.04f, average trigger: %.04f\n", lock, tfom, weight_, adel, aoff);
  }
  return 0;
}

