/****************************************************************************/
/*                                                                          */
/*   partlib_common.h: you need this if you plan on using objects and        */
/*                    methods in the partlib library                         */
/*                                                                          */
/****************************************************************************/
#ifndef _PART_COMMON_H
#define _PART_COMMON_H

/*---------------------------------------------------------------------------*/
/* Includes */                              
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <math.h>   
#include <fcntl.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

/*---------------------------------------------------------------------------*/
/* Part Library / IC interface routines */
#define PTCFG_PIN_BASE 0   /* Select base address for PIN register     */
#define PTCFG_RG_BASE  1   /* Select base address for part registers   */
#define PTCFG_RG_WROFF 2   /* Select address offset for register write */
#define PTCFG_RG_RDOFF 3   /* Select address offset for register read  */
#define PTCFG_ADDR_MAX 4   /* Maximum number of address array elements */
#define PTCFG_ID_INVALID 0xFFFFFFFF /* Invalid Part identifier - DO NOT REUSE */

#endif /* _PART_COMMON_H */
