#ifndef _PART_NULLPART_H
#define _PART_NULLPART_H

#include "part_common.h"

/*---------------------------------------------------------------------------*/
/* NULLPART Object */
#define NULLPART_ID        0x0001 /* 16-bit unique part identifier      */
#define NULLPART_RG_MAXCNT 1      /* Maximum of 6 configuration registers */
typedef struct
{
  uint16_t id;         /* Part identifier (validates structure contents)     */
  int8_t   debuglevel; /* Diagnostic output level                            */
  int8_t   mtype;      /* Module type                                        */
  uint32_t pinval;                    /* NULLPART Pin I/O Register          */
  uint16_t addr[PTCFG_ADDR_MAX];      /* Base and offset addresses          */
  uint16_t rgadd[NULLPART_RG_MAXCNT]; /* NULLPART Register Address Offset   */
  uint32_t rgval[NULLPART_RG_MAXCNT]; /* NULLPART Register Value            */

} NULLPART_Reg_Obj;

/* NULLPART Register ID's */
#define NULLPART_RG_0h   0 

#endif /* _PART_NULLPART_H */
