#ifndef _PART_PE4302_H
#define _PART_PE4302_H

#include "part_common.h"

/*---------------------------------------------------------------------------*/
/* PE4302 Object */
#define PE4302_ID        0xDB76CE60 /* 32-bit unique part identifier      */
#define PE4302_RG_MAXCNT 1          /* Maximum of 1 configuration registers */
typedef struct
{
  int32_t id;         /* Part identifier (validates structure contents)     */
  int8_t  mtype;      /* Module type                                        */
  int8_t  debuglevel; /* Diagnostic output level                            */
  uint8_t pinval;                  /* PE4302 Pin I/O Register         */
  uint16_t addr[PTCFG_ADDR_MAX];    /* Base and offset addresses       */
  uint16_t rgadd[PE4302_RG_MAXCNT]; /* PE4302 Register Address Offset  */
  uint8_t  rgval[PE4302_RG_MAXCNT]; /* PE4302 Register Value           */

} PE4302_Reg_Obj;

/* PE4302 PIN register ID */
#define PE4302_RG_PIN  1                 /* User control of device pins */

/* PE4302 Register ID's */
#define PE4302_RG_0h   0 

/* PE4302 Pin Keys      */
#define PE4302_RG_PIN_LE      0x00000001 /* Latch Enable / Disable          */

/* PE4302 Register Keys */
#define PE4302_RG_0h_ATTN     0x0000003F /* 7-bit Attenuation in 0.5dB step */

#endif  /* _PART_PE4302_H */
