!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! ICE - Utility macro for ICE software/hardware development
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
startmacro u:function u:p1 u:p2 u:p3 u:p4 u:p5 u:p6 u:p7

global/readall 

if reg.handlers.packet.ice eqss "nxm.sys" then
  set reg.handlers.packet.ice "nxm.ice.lib.ICEPacket"
  set reg.handlers.packet.vrt "nxm.ice.lib.VRTPacket"
endif

fname afn home iceauto tbl aux
if "HWALIAS" nrexists and afn fexists then set/global T:HWALIAS ^afn

if function eqss "APP" then
  snapapp/^function,^p1,^p2,^p3,^p4,^p5,^p6,^p7

elseif function eqs "AUTOCONFIG" or function eqs "AUTO" then
  fname afn home iceauto tbl aux
  picd/stat=npic detect 
  file open/t/n afh afn 
  set/parent "T:HWALIAS" {}
  do n 1 npic
    set "HWALIAS_PIC" "ICEPIC,DEVNO=^l:calc(n-1),IOM=NONE,PM=NONE,"
    picd get "PIC" "CONFIG" "ALIAS"
    set "HWALIAS.PIC^{n}AUTO" ALIAS
    file write afh "PIC^{n}AUTO="^ALIAS""
  enddo
  file close afh 

elseif function eqs "BUILD" then
  bld ^p1 ^p2 ^p3

elseif function eqs "CLEAN" then
  pic clean 

elseif function eqs "DETECT" then
  picd detect

elseif function eqs "DIFF" then
  icediff ^p1 ^p2

elseif function eqs "DIR" then
  pic dir

elseif function eqs "DRIVER" then
  $cat /proc/driver/icepic

elseif function eqs "EDIT" then
  if p1 eqss "APPS"
    edit snapapp.tbl tbl ice
  elseif p1 eqss "LIB"
    edit icelib.c lib ice
  elseif p1 eqss "HWF"
    edit hwconfig.key dat ice
    hw cfg
  else
    warn "Unrecognized edit target: ^p1"
  endif

elseif function eqss "EXP" then
  explain ice

elseif function eqs "FILES" then
  files

elseif function eqs "FLASH" then
  picd loadflash ^p1 ^p2

elseif function eqss "HELP" then
  if p1 eqs "" res p1 "MAINHELP"
  env get nmroot nmr
  file name icedoc (^nmr,htdocs,index) segments gen
  if icedoc nfexists help/index
  run ^function ^p1,ice

elseif function eqs "HOME"
  fname icefat fat ,,, ice
  homepath icefat

elseif function eqs "INSTALL"
  error "This function must be run from outside the Midas shell"

elseif function eqs "MAKE"
  icemake,^p1,^p2,^p3

elseif function eqs "PFAT"
  pic pfat ^p1

elseif function eqs "PLOT" then
  plot ^p1

elseif function eqs "RESET"
  picdriver reset ^p1

elseif function eqs "SHELL"
  shellgui

elseif function eqss "SNAP" then
  snapper/^function,^p1,^p2

elseif function eqss "STAT" then
  pic status ^p1

elseif function eqss "TEST" then
  icetest/^function,^p1,^p2

elseif function eqs "UNPACK"
  error "This function must be run from outside the Midas shell"

else
  warn "Unsupported ICE function: ^function
endif

endmacro
