!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  ICETEST - Test macro for ICE-PIC DSP cards
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
startmacro u:function u:p1 u:p2 u:p3 u:p4 u:p5 u:p6 u:p7

global/readall 
set aflags ^/aflags

if env.ramaux rexists then
  res ramqual "{CTG=1,AUX=^{ENV.RAMAUX},DET=1}"
else
  res ramqual ""
endif

fname icefat fat ,,, ice

if function eqs "EXP" then
  explain icetest

elseif function eqs "ALL" then
  picd test ^p1 0

elseif function eqs "PFAT" then
  homepath icefat
  if p1 eqss "E2D" or p1 eqs "D2E" or p1 eqs "A2D" then
    %testmod/noext/noxlink ix ^p1 5 pico
  else
    %testcard/noext/noxlink ^p1 5
    if /nox isfalse %testtuners/hs/c ^p1
  endif
  homepath restore

elseif function eqs "MOD/RT" then

  if p2 eqs "" res p2 "1"
  res p2a ^p2
  res p2b 3-^p2
  if p3 eqs "" res p3 "4K"	! FFT size
  if p4 eqs "" res p4 "1K"	! decimation
  if p5 eqs "" res p5 "20e6"	! rate
  if p7 eqs "" res p7 "TRAMP"	! shape
  res sr p5

  picd reset ^p1 t^p2a /flags=^aflags
  if /ext gt 0 picd reset ^p1 lt^{p2a}
  if /int gt 0 picd reset ^p1 iir

  if p6 neqs ""
    res sr 1/p6(hcb.xd)
  else
    res p6 "testin"
    pic create testin si 1m sr ^p7
  endif
  picd create testout si 4m sr

  if /form neqs "NULL"
    header testin form=^/form
    header testout form=^/form
  endif

  pipe/panel/setup=RT on 
  sourcepic/id=s1/tl=1/port=module^p2a/flags=alt|muxclk=i|^aflags &
			testout{fs=^p3} _cb , ^p1, ^p4 
  if /tout gt 0
    picd/replay=5/pause=0.25/port=module^p2b/flags=^aflags play ^p1 ^p6 
  elseif /int le 0 
    picd/replay=2/pause=0.25/port=module^p2b/flags=^aflags play ^p1 ^p6 
  endif
  fft/psd/log _cb _cbf ^p3 HANN  
  plot/id=plot1 _cb cm=re type=line
  plot/id=plot2 _cbf type=line
  plot/id=plot3 _cbf type=raster
  call setupControls
  pipe off
  picd reset ^p1 

elseif function eqs "TUN/RT" then

  res sr 8e6
  if p2 eqs "" res p2 "1"
  calc l:p2a ^p2-1 2 mod 1 +
  calc l:p2b ^p2 2 mod 1 +
  if p3 eqs "" res p3 "1K"	! FFT size
  if p4 eqs "" res p4 "256"	! decimation
  if p5 eqs "" res p5 sr/128.1	! frequency

  picd reset ^p1 t^p2a
  if /ovsr ge 0
    picd OVSR ^p1 ,, //ovsr
    calc sr sr /ovsr /
  endif
  if p6 neqs ""
    res sr 1/p6(hcb.xd)
  else
    res p6 "testin"
    waveform testin^ramqual si 64k saw 20000 sr/128 ,,, 1/sr
  endif
  res scale 32k
  res dbmax 70
  switch "FORM" format get "CI"
  picd create testout1 format 64k sr/^p4
  picd create testout2 si 4m sr
  if "C" subs format header testout1 xd=2*^p4/sr
  if "L" subs format res scale 2G
  if "L" subs format res dbmax 150

  pipe/panel/setup=RT on 
  picd/replay=2/port=module^p2b/pause=0.25 play ^p1 ^p6 
  sourcepic/id=s1/tl=1/port=tuner^p2/flags=^aflags &
		testout1{fs=^p3} _cb1 , ^p1, ^p4, ^p5
  sourcepic/id=s2/tl=1/port=module^p2a/flags=^aflags/host=n &
		testout2{fs=^p3} _cb2 , ^p1, 256 
  fft/psd/log _cb1 _cbf1 ^p3 HANN 0 5
  fft/psd/log _cb2 _cbf2 ^p3 HANN 0 5
  plot/id=plot1 _cb1{fs=^p3} y1=-scale y2=scale cm=re type=line
  plot/id=plot2 _cbf2 type=rast z1=-80 z2=40 cnt=motion /msgid=main 
  plot/id=plot3 _cbf1 type=line y1=dbmax-140 y2=dbmax
  call setupControls
  pipe off
  picd reset ^p1 

elseif function eqs "TUN/RT2" then

  res sr 10e6
  res dec 256
  res nfft 1k
  res freq sr*.0167
  res dfreq sr*.001
  picd reset ^p1 t2
  pic create testin si 1m sr "WHITE"
  pic create testout1 si 32K sr/dec 
  pic create testout2 si 32K sr/dec 
  pipe/panel/setup=RT on 
  sinkpic/port=module1/wrap/flags=muxclk=p/wait=1.5 testin testin ^p1
  sourcepic/id=SP1/port=tuner1/flags=muxclk=p/master=SP2/tl=1 &
    testout1{fs=nfft} _cb1{ps=2m} ^p1 dec freq /dfreq=dfreq 
  sourcepic/id=SP2/port=tuner2/flags=muxclk=p/slave/tl=1 &
    testout2{fs=nfft} _cb2{ps=2m} ^p1 dec freq /dfreq=dfreq 
  fft _cb1 _cb1f nfft HANN 0 1 _cb2 _cb2f _cbxf
  plot/id=plot2 _cbxf  cm=10log /dbrange=100
  plot/id=plot3 _cbxf  cm=phase
  call setupControls
  pipe off
  picd reset ^p1 

elseif function eqs "TUN/LB2" then

  res sr 10e6
  res dec 16
  res nfft 1k
  res freq sr/16+1000
  res dfreq sr/dec/4
  picd reset ^p1 ios
  pic create testout1 si 1m sr/dec 
  pic create testout2 si 256k sr/dec 
  pic create testout3 si 32K sr/dec/dec
  pipe/panel/setup=RT on 
  sourcepic/id=SP1/port=tuner1/flags=ipconn=224.1.2.3/tl=1 &
    testout1{fs=nfft} _cb1{ps=2m} ^p1 dec freq
  sourcepic/id=SP2/port=tuner2/flags=muxclk=i/tl=1 &
    testout3{fs=nfft} _cb2{ps=2m} ^p1 dec dfreq
  sinkpic/port=module2/flags=muxclk=i/throttle=cont/srate=800e3 &
    _cb1 testout2 ^p1
  fft _cb1{fs=0} _cb1f nfft HANN -16 1 
  fft _cb2{fs=0} _cb2f nfft HANN 0 1 
  plot/id=plot2 _cb1f cm=10log /dbrange=100
  plot/id=plot3 _cb2f cm=10log /dbrange=100
  call setupControls
  pipe off
  picd reset ^p1 

elseif function eqs "CHAIN/RT" then

  res sr 10e6
  pic create testout1 si 1m sr "RAMP"
  pic create testout2 si 1m sr "SINE"
  pic create testout3 si 1m sr "LRS"
  pic create testout4 si 1m sr "TRAMP"
  picd create testin si 8m sr 
  picd reset ^p1

  picd/flags=muxclk=p/replay=-20/port=module2/wrap/bg/dmac=dmac &
    chain ^p1 testout1|testout2|testout3|testout4
  set this.pc.reg.table.chainpic reg.picdriver

  if /autostop gt 0 then
    pause ^/autostop 
    picd/port=module2 set ^p1 chain 1
  endif

elseif function eqs "MULTI" then

  homepath icefat
  if p2 eqs "" set p2 "256"
  %testtuners/hs/form=sl/mux=3/nplot=^p2 ^p1 dec=1k
  homepath restore

elseif function eqs "ALLPORTS" then

  homepath icefat
  %testall ^p1
  homepath restore

elseif function eqs "SDDSGEN" then

  say "need:  route add -net 224.0.0.0 netmask 240.0.0.0 dev eth0"
  if p1 eqs "PIC" set p1 "224.1.2.3:9001"
  if p2 eqs "" set p2 "SB"
  if p3 eqs "" then
    set p3 "100"
    if p2 eqs "SI" set p3 "20000"
  endif
  if p4 eqs "" set p4 "10e6"
  if p5 eqs "" set p5 "sin"
  if p6 eqs "" set p6 "^p4/16"
  switch port l:port get 9001
  if this.pc.reg.table.sddsgen rexists and /nocheck isfalse
    say "Killing old SDDS Software Generator"
    set this.pc.reg.table.sddsgen.state "STOP"
  endif
  if this.pc.reg.table.picdriver rexists and /nocheck isfalse
    say "Killing old SDDS Hardware Generator"
    set this.pc.reg.table.picdriver.state "STOP"
  endif
  erase sdds1
  say "Generating SDDS src=^port dest=^p1 form=^p2 amp=^p3 rate=^p4 shape=^p5"
  set flg "IPADDR1=192.9.200.177|IPADDR2=192.9.200.178|IPDEST1=224.1.2.3|IPDEST2=224.1.2.4"
  if /fast then
    picd reset ^p1
    pic create sdds1 ^p2 16K ^p4 ^p5 ^p3 ^p6
    picd/replay=spin/port=module2/flags=muxclk=p|^flg play ^p1 sdds1
  elseif /fasttc then
    picd reset ^p1 
    waveform sdds2f shape=^p5 elem=100m form=^p2 amp=^p3 delta=1/^p4 freq=1e6
    header sdds2f tc=2006:11:22::12:34:56
    calc srate ^p4 1080/1024 * 
    erase sdds1
    sinksdds sdds2f sdds1^ramqual
    key sdds1 del "PACKET"
    picd/bg/replay=cont/port=module2/srate=srate/flags=muxclk=p|TXRAWDATA|^flg/bits=16 play ^p1 sdds1
    set this.pc.reg.table.picdriver reg.picdriver
  else
    pic create sdds1 ^p2 50m ^p4 ^p5 ^p3 ^p6
    header sdds1 tc=2006:11:22::12:34:56
    sinksdds/bg/wrap/rt/inmem sdds1 udp:^port/^p1
    set this.pc.reg.table.sddsgen reg.sinksdds
  endif

elseif function eqs "SDDSGEN1" then

  if p1 eqs "PIC" set p1 "224.1.2.3:9001"
  waveform sdds1 shape=sin elem=1m form=si amp=10000 delta=1e-6 freq=10e3
  sinksdds/bg/wrap/rt/inmem sdds1 udp:9001/^p1

elseif function eqs "SDDSGEN2" then

  if p1 eqs "PIC" set p1 "224.1.2.3:9001"
  waveform sdds2 shape=saw elem=1m form=si amp=10000 delta=1e-6 freq=10e3
  sinksdds/bg/wrap/rt/inmem sdds2 udp:9002/^p1

elseif function eqs "SDDSGEN11" then

  if p1 eqs "PIC" set p1 "224.1.2.11:9001"
  waveform sdds1 shape=sin elem=1m form=si amp=10000 delta=1e-7 freq=1e7/16
  sinksdds/bg/wrap/rt/inmem sdds1 udp:9001/^p1

elseif function eqs "SDDSGEN12" then

  if p1 eqs "PIC" set p1 "224.1.2.12:9001"
  waveform sdds2 shape=saw elem=1m form=si amp=10000 delta=1e-7 freq=1e7/16
  sinksdds/bg/wrap/rt/inmem sdds2 udp:9002/^p1

elseif function eqs "SDDSOUT" then

  header ^p1 form=sb fs=1088
  sdds unpack ^p1 testd testp
  split testp testp_
  header testp_fram datarep=ieee
  fcalc diff testp_fram(1:) testp_fram -
  plot diff y1=-10 y2=10
  header ^p1 form=sb fs=0
  key ^p1 put packet sdds/ice /scope=main
  data/p ^p1
  status ^p1
  key ^p1 del packet /scope=main

elseif function eqs "SDDSIO" then

  snapapp sdds1
  snapapp sdds2
  snapapp sdds3
  snapapp sdds4

elseif function eqs "TCGEN" and /SDDS then

  if p2 eqs "" res p2 "10"
  pipe on /panel
  calc ps 16m
  calc rate ^p2 1e6 *
  res port "224.1.2.3:9001"
  waveform _data{ps=ps} shape=lrs elem=1e12 form=si amp=10000 delta=1/rate freq=rate/16
  if /rayday then
    icetc insert SDN0 _data _datatc{ps=ps} 364::23:59:45
  else
    icetc insert SDN0 _data _datatc{ps=ps} 123::12:34:56
  endif
  sinksdds/rt _datatc udp:9001/^port
  say "Running ^function to ^port at ^p2 MHz"
  pipe off

elseif function eqs "TCGEN" then

  if p2 eqs "" res p2 "10"
  if /LOOP then
    picd reset ^p1 t1nw 
  else
    picd reset ^p1 oow 
  endif
  if /NOFILL then
    picd/flags=tp=1 test ^p1 1000+^p2 
  else
    picd test ^p1 1000+^p2
  endif

elseif function eqs "TCGEN/SDDS/N" then

  pipe on /panel
  calc ps 16m
  calc rate ^p2 1e6 *
  res port "224.1.2.3:9001"
  waveform _data{ps=ps} shape=lrs elem=1e12 form=sn amp=7 delta=1/rate freq=rate/16
  timex 123::12:34:56 file=_data
  sinksdds/rt _data udp:9001/^port
  say "Running ^function to ^port at ^p2 MHz"
  pipe off

elseif function eqs "TCGEN/SDDS/LIVE" then

  switch "FORM" form get "SI"
  switch "SHAPE" shape get "LRS"
  say "Running ^function on ^^p1  Form=^form Shape=^shape Rate=^{p2}MHz"
  if form eqs "SB"
    set amp 100
  elseif form eqs "SN"
    set amp 7
  elseif shape eqs "RAMP"
    set amp 32K
  else
    set amp 10000
  endif
  calc ps 16m
  calc rate ^p2 1e6 *
  picd reset ^p1 /flags=^/aflags
  pic create testsddsout form rate rate
  pipe on /panel /setup=t /logger
  shellgui/id=term/attach
  waveform _data{ps=ps,tc=123::12:34:56} shape=shape elem=1e12 form=form amp=amp delta=1/rate freq=rate/100
  if form eqs "SI" then
    icetc insert SDN0 _data _datatc{ps=ps} 
    set sdfeed _datatc
  else
    set sdfeed _data
  endif
  if /inline then
    sinkpic/port=module2/stats sdfeed testsddsout ^p1 /flags=muxclk=p|^/aflags
  else
    sinksdds sdfeed _datatcsdds{ps=ps}
    sinkpic/port=module2/stats _datatcsdds{packet=none} testsddsout ^p1 /srate=rate*1080/1024 /flags=muxclk=p|txrawdata|^/aflags
  endif
  gcontrol button "ITEM" "Function" "Exit" 
  pipe off

elseif function eqs "TCGEN/I" then

  picd reset ^p1 oow
  if p2 eqs "" res p2 "1000"
  picd test ^p1 3000+^p2

elseif function eqs "TCGLITCH" then

  if p2 eqs "" res p2 "50"
  picd test ^p1 2000+^p2

elseif function eqs "TCMEAS" then

  homepath icefat
  if p2 eqs "" res p2 "50"
  if p3 eqs "" res p3 "1k"
  if p4 eqs "" res p4 "-1"
  picd reset ^p1
  %testtuners/mux/meas/tcx/tc=sdn0/tctolr=10e-9/nox/aflags=itdecx/wbpx=2 &
     ^p1 ,,, ^p3 ,^p4, ^p2*1e6 ^p2*1e6/5
  homepath restore

elseif function eqs "PPC/GET" then

  waveform ppco shape=sin form=sl elem=128 amp=0
  picd recv ^p1 ppco ^p2
  data/hex/nc=2 ppco
!  plot ppco cm=rni

elseif function eqs "PPC/DMA" then

  picd get ^p1 pmtype1 pmtype1 
  picd get ^p1 pmtype2 pmtype2 
  waveform ppco shape=sin form=sl elem=32 amp=0
  picd recv ^p1 ppco 0xfd810F00
  say "Dma R2X  00=PRC,02=HOST,04=HA,06=HB,08=CA,10=CB,12=TA,14=TB"
  data/hex/nc=2 ppco 0 16
  say "Dma X2R  16=PRC,18=HOST,20=HA,22=HB,24=CA,26=CB,28=TA,30=TB"
  data/hex/nc=2 ppco 16 16
  switch "NTUN" ntun get 32
  waveform ppco shape=sin form=sl elem=ntun amp=0
  picd recv ^p1 ppco 0xfd810000
  say "Dma T2R  00=Chan0 , 01=Chan1 ... N=ChanN"
  data/hex/nc=2 ppco 0 ntun
  picd "ROUTE" ^p1

elseif function eqs "PPC/FTT" then
  waveform ppco shape=sin form=sl elem=86 amp=0
  picd get ^p1 "PMTYPE" pmtype
  picd recv ^p1 ppco 0x480
  say "FTT stages,active,cstage,lstage,busy,chantop,bits,speed"
  data/nc=8 ppco 0 8
  say "FTT taddr"
  data/hex/nc=8 ppco 8 16
  do n 0 2
    say "FFT mchan,nchan,dec,cpc,xfer,cons,prod,chan,index      : pass=^n"
    say "FTT pcfg,pstrt,psize,pmask,pindx"
    say "FTT phinc,dphinc,tphinc,tdphinc,tphase,tdphase"
    data/nc=9 ppco n*20+24 9
    data/hex/nc=6 ppco n*20+33 5
    data/hex/nc=6 ppco n*20+38 6
  enddo
  say "FTT omoda,omodb"
  data/nc=8 ppco 84 2
  picd "ROUTE" ^p1

elseif function eqs "PPC/DUMP" then
  if p3 eqs "" res p3 "16M"
  waveform ppco shape=zero form=sl elem=^p3 amp=0
  picd recv ^p1 ppco ^p2

elseif function eqs "PPC/PEEK" then

  if p3 eqs "" res p3 "64"
  waveform ppco shape=sin form=sl elem=^p3 amp=0
  picd recv ^p1 ppco ^p2
  data/hex/nc=4 ppco 0 -1

elseif function eqs "PPC/POKE" then

  if p3 eqs "" res p3 "64"
  waveform ppco shape=saw form=sl elem=^p3 amp=0
  picd send ^p1 ppco ^p2
  data/hex/nc=4 ppco 0 -1

elseif function eqss "CORE" then
  if /RO isfalse
  do nn 0 8
    res l:aa (nn*4)
    picd/port=^function set ^p1 CORE+^aa 0x01CE0000+(aa*64)
  enddo
  endif
  do nn 0 8
    res l:aa (nn*4)
    picd/port=^function get ^p1 CORE+^aa /hex
  enddo

elseif function eqs "LOOP" then

  calc l:terrors 0
  if p3 eqs "" res p3 10000
  do ii 1 p3 
    picdriver test ^p1,^p2,errors
    calc l:terrors terrors errors +
    say " **********************   Loop=^ii, Errors=^errors Total=^terrors"
  enddo

elseif function eqs "SPEC" then

  picd reset ^p1 /flags=tpoe=1
  picd get ^p1 pcibw scale
  picd get ^p1 type ctype 
  if ctype ge 5 and ctype le 8 
    set block "256K"
  else
    set block "4K"
  endif
  pipe on /panel
  picd/id=p1 specs ^p1 _specs /todo=inf /block=^block
  plot/id=plot1 _specs y1=0 y2=scale /lps=512 /layer={ct={SRAT=Green,BRAT=White,PRAT=Gray}}
  call setupControls
  gcontrol choice "BLOCK" "Block " "1K,2K,4K,8K,16K,32K,64K,128K,256K,512K,1M" block
  if /pcidbg then 
    gcontrol menu "PCIDEBUG" "PCIe NACK Injector" &
	"Root NACK,Root NACKs x4,Root NACKs x100,Card NACK,Card NACKs x4,Card NACKs x100,Show NACK Count"
  else
    gcontrol list "LEGEND" "Legend" "Green->Sustained-Acq,White->Blocked-Acq,Grey-->Sustained-Play" 20 3 /title
  endif
  pipe waitfor p1
  pipe off

elseif function eqs "SLOT" then

  if p1 eq 1
    res l:icepics (0,1,2,3)
  elseif p1 eq 2
    res l:icepics (1,0,2,3)
  elseif p1 eq 3
    res l:icepics (2,1,0,3)
  elseif p1 eq 4
    res l:icepics (3,1,2,0)
  else
    warning "Cant sub slot ^p1 into slot 1"
  endif
  env set icepics icepics

else

  warn "Unsupported function=^function"

endif

endmacro

procedure setupControls
gcontrol label "GC" "General Control"
gcontrol button "ITEM" "Function" "Oneshot,Cont,Stop,ReStart,Exit" /nc=2
gcontrol label "AC" "Application Control"
set this.timers 1
set this.timer(0) 10
sendto "MAIN" "TIMER"
return

procedure processException
say "^emsg.data"
stop
return

procedure processMessage
if msg.name eqs "MARK"
  if msg.fid eqs "PLOT2"
    set reg.s1.freq msg.data.x
  endif

elseif msg.name eqs "ITEM"
 if msg.data eqs "EXIT"
   stop
 elseif reg.s1 rexists 
   set reg.s1.replay msg.data
 endif

elseif msg.name eqs "TIMER" 
  if /pcidbg then
    picd get ^p1 "PCINACK" nacks
  endif

elseif msg.name eqs "FREQ"
  set reg.s1.freq msg.data

elseif msg.name eqs "BLOCK"
  set reg.p1.block ^msg.data

elseif msg.name eqs "PCIDEBUG"
  if msg.data eqs "SHOW NACK COUNT" then
    picd get ^p1 "PCINACK" nacks
  elseif msg.data eqs "ROOT NACK" then
    picd test ^p1 17 /flags=tpcnt=0x10
  elseif msg.data eqs "ROOT NACKS X4" then
    picd test ^p1 17 /flags=tpcnt=0x40
  elseif msg.data eqs "ROOT NACKS X100" then
    forall #=1:25 picd test ^p1 17 /flags=tpcnt=0x40
  elseif msg.data eqs "CARD NACK" then
    picd test ^p1 17 /flags=tpcnt=0x01
  elseif msg.data eqs "CARD NACKS X4" then
    forall #=1:4 picd test ^p1 17 /flags=tpcnt=0x01
  elseif msg.data eqs "CARD NACKS X100" then
    forall #=1:100 picd test ^p1 17 /flags=tpcnt=0x01
  endif
endif
return


