!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  PIC - Utility macro for ICE-PIC DSP cards
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
startmacro u:function u:p1 u:p2 u:p3 u:p4 u:p5 u:p6 u:p7

global/readall 

if env.ramaux rexists then
  res ramqual "{CTG=1,AUX=^{ENV.RAMAUX},DET=1}"
else
  res ramqual ""
endif

if reg.handlers.packet.ice eqss "nxm.sys" then
  set reg.handlers.packet.ice "nxm.ice.lib.ICEPacket"
  set reg.handlers.packet.vrt "nxm.ice.lib.VRTPacket"
endif

fname icefat fat ,,, ice

if function eqs "AUX" then

  if env.ramaux nrexists env set ramaux aux.write
  if p1 eqs "PIC"  ask s:p1 "Ram Aux [^env.ramaux]: "
  if p1 neqs env.ramaux env set ramaux p1

  res picaux aux.^env.ramaux
  if "RAM,AUTO" subs picaux and env.osname eqs "Linux" then
    file open/t drvcfg "/proc/driver/icepic{FLAGS=NOABORT}"
   if drvcfg.isopen then
    file read drvcfg rstart
    file read drvcfg rdisk
    sedit rstart rstart trim ":" "Mby" strim
    sedit rdisk rdisk trim ":" "Mby" strim
    sedit picaux picaux subs ",ram," ",RAM," subs ",auto" ",AUTO"
    sedit picaux picaux subs "AUTO" "^{rstart}M,^{rdisk}M,"
    file close drvcfg
    if /quiet isfalse then info "Auto config of PIC aux = ^picaux"
   else
    warn "Unable to open driver for ICEPIC RAM AutoConfig"
   endif
    set s:aux.^env.ramaux picaux
  endif

  fname afn home iceauto tbl aux
  if "HWALIAS" nrexists and afn fexists then set/global T:HWALIAS ^afn

elseif function eqs "DIR" then
  files/h ,,, env.ramaux

elseif function eqs "CLEAN" then
  if p1 eqs "PIC" set p1 env.ramaux
  if /batch istrue then
    files/e ,,, p1
  else
    files/h ,,, p1
    if p1 eqs env.ramaux then
      ask answer "Erase ICERAM files: All/Some/[None]? "
    else
      ask answer "Erase AUX=^p1 files: Some/[None]? "
    endif
    if answer eqss "A" then
      files/e ,,, p1
      files/e ,, det p1 ! also erase orphaned detached files
    elseif answer eqss "S" then
      files/f ,,, p1
      foreach name infile files
        ask answer "Erase FILE=^name Y/[N]? "
        if answer eqss "Y" erase name
      endfor
      erase files
    endif
  endif

elseif function eqs "COPY" then
  noop ^p1 ^{p2}^ramqual

elseif function eqs "SNAP" then
  snapper ^p1,^p2

elseif function eqs "APP" then
  if p1 eqs "PIC" then
    snapapp ,,
  elseif p1 neqs "" and p2 eqs "" then
    snapapp/batch ,, ^p1
  else
    snapapp ,, ^p1,^p2
  endif

elseif function eqs "APPS" then
  res t:apps nxm.ice.tbl.snapapp.tbl
  if p1 eqs "PIC" then
    foreach key intable apps
      if key neqss "CASE_" continue
      sedit key name "TRIM" "CASE_"
      say "App=^name Card=^apps.^{key}.card"
    endfor
  else
    res apps.case_^p1
  endif

elseif function eqs "EDIT" then
  if p1 eqss "APPS"
    edit snapapp.tbl tbl ice
  elseif p1 eqss "LIB"
    edit icelib.c lib ice
  elseif p1 eqss "HWF"
    edit hwconfig.key dat ice
    hw cfg
  else
    warn "Unrecognized edit target: ^p1"
  endif

elseif function eqs "CREATE" then
  set p1 this.args.getCS("P1")  ! re-get this case sensitive

  if p1 eqs "PIC" ask q:p1 "Filename [RAMFILE]: "
  if p2 eqs ""    ask u:p2 "Format [SB]: "
  if p3 eqs ""    ask u:p3 "Samples [1M]: "
  if p4 eqs ""    ask u:p4 "SampleRate [1e6]: "
  if p5 eqs "TEST" ask u:p5 "Options (RAMP|WHITE|LRS|BITS|SINE|ZERO|0XFFFF|0X5A5A|TONES|TRAMP|NOTCH) [NONE]: "

  res amp 30720
  if "L" subs p2 res amp 2e9-1
  if "B" subs p2 res amp 120
  if "N" subs p2 res amp 7
  if "P" subs p2 res amp 1

  if p6 eqs "" then
  elseif p6 le 6 then ! in db
    calc amp amp 2 ^p6/6 ** *
  else
    calc amp ^p6
  endif
  invoke bpa nxm.sys.lib.Data.getBPA(p2)
  if bpa le 0 calc bpa -bpa/8
  if /power2 then
    calc samp ^p3 power2
  elseif /round gt 0
    calc samp ^p3 bpa * /round / round 1 max /round * bpa /
  else
    res samp ^p3
  endif
  if p5 eqs "RAMP" 
    ramp ^{p1}^ramqual p2 samp 0 1 0 1/^p4
  elseif p5 eqs "TRAMP" 
    ramp ^{p1}^ramqual p2 samp 0x0001 0x0103 0 1/^p4
  elseif p5 eqs "RAMPI" 
    ramp ^{p1}{DATAREP=IEEE}^ramqual p2 samp 0 1 0 1/^p4
    header ^{p1}^ramqual datarep=eeei
    res limit 32768
    fcalc/type=l ^{p1}{form=SI}^ramqual ^{p1}^ramqual limit min -limit max
  elseif p5 eqs "RAMPJ" 
    ramp ^{p1}^ramqual p2 samp 27 256 0 1/^p4
  elseif p5 eqs "WHITE" or p5 eqs "LRS"
    waveform ^{p1}^ramqual ^p2 samp ^p5 amp/2 0 0 0 1/^p4 /seed=123456
  elseif p5 eqs "BITS"
    waveform testbits ^p2 samp RAMP amp 256+3 0 0 1/^p4
    header testbits f=sp
    reformat testbits ^{p1}^ramqual si
  elseif "|^p5|" subs "|SINE|SIN|SAW|TRI|SQUARE|ZERO|"
    if p7 eqs "" res p7 "^p4/128"
    waveform ^{p1}^ramqual ^p2 samp ^p5 amp ^p7 0 0 1/^p4
  elseif p5 neqs "" and p5 eqss "0X"
    waveform ^{p1}^ramqual ^p2 samp "CONSTANT" ^p5 ^p4/16 0 0 1/^p4
  elseif p5 eqs "MIXLS" then
    if p7 eqs "" res p7 "^p4/128"
    pipe on
    waveform _t1 sf samp "SIN" amp/2 ^p7 0 0 1/^p4 
    waveform _t2 sf samp "LRS" amp/2 ^p7 0 0 1/^p4
    fcalc ^{p1}{FORM=^p2}^ramqual _t1 _t2 + 
    pipe off
  elseif p5 eqs "MUXLS" then
    if p7 eqs "" res p7 "^p4/128"
    pipe on
    waveform _t1 ^p2 samp "SIN" amp/2 ^p7 0 0 1/^p4 
    waveform _t2 ^p2 samp "LRS" amp/2 ^p7 0 0 1/^p4
    fcalc ^{p1}{FORM=CI}^ramqual _t1 _t2 mux
    pipe off
    header ^{p1}^ramqual form=^p2
  elseif p5 eqs "TONES"
    firwind tmpfir bandpass hann 256 ^p4/5 ^p4/4 ^p4/2
    pipe on
    waveform _t1 sf samp "SIN" amp/4 ^p4/4 0 0 1/^p4
    waveform _t2 sf samp "SIN" amp/4 ^p4/11 0 0 1/^p4
    waveform _t3 sf samp "SIN" amp/4 ^p4/12 0 0 1/^p4
    waveform _t4 sf samp "SIN" amp/4 ^p4/30 0 0 1/^p4
    waveform _t5p sf samp "WHITE" amp/4 ^p4/30 0 0 1/^p4
    fdfilter/pad _t5p tmpfir _t5
    fcalc tmpram _t1 _t2 + _t3 + _t4 + _t5 +
    pipe off
    reformat tmpram ^{p1}^ramqual p2
  elseif p5 eqs "NOTCH"
    firwind tmpfir STOPBAND BH92 1k .11 .14 .5
    pipe on
    waveform _t1 sf samp lrs amp ,,, 0 1/^p4
    fdfilter/pad _t1 tmpfir _t2
    fdfilter/pad _t2 tmpfir _t3
    fdfilter/pad _t3 tmpfir tmpram
    pipe off
    reformat tmpram ^{p1}^ramqual p2
  else
    picd create ^p1 ^p2 samp ^p4
  endif
  if /notch then
    firwind tmpfir STOPBAND BH92 1k .11 .14 .5
    fdfilter/pad ^{p1}^ramqual tmpfir ^{p1}^ramqual
    fdfilter/pad ^{p1}^ramqual tmpfir ^{p1}^ramqual
    fdfilter/pad ^{p1}^ramqual tmpfir ^{p1}^ramqual
  endif

elseif function eqs "COPY" then
  noop ^p1 ^{p2}^{ramqual}

elseif function eqss "EXP" then
  explain pic

elseif function eqs "HELP" then
  if p1 eqs "PIC" res p1 "MAINHELP"
  run help ^p1,ice

elseif function eqs "HOME" then
  homepath icefat

elseif function eqss "FSTATS" then
  sedit p1 p1 "LOCASE"
  if p2 eqs "" set p2 "SP"
  file open/d/r fmlog ^{p1}.mlog
 if /gap then
  file open/d/n fstat ^{p1}_^{p2}_gstat{SR=(GMIN/SL,GMAX/SL)}
 else
  file open/d/n fstat ^{p1}_^{p2}_fstat{SR=(FAVG/SL,FMIN/SL,FMAX/SL)}
 endif
  set nn 0
  foreach index insize fmlog.size
    set rec fmlog.dataTable(index)
    if rec.from eqs p2 and rec.type eqs "INFO" and "STATS=" subs rec.text then
      sedit rec.text t:tab "TRIM" "STATS="
      set fstat.data(nn) tab
      set l:nn nn+1
    endif
  endfor
  file close fmlog
  file close fstat
  if "/L" subs function then
    say "Viewing tail of status log"
    list/bg ^{p1}.mlog(-20:)
  endif
  if "/P" subs function then
    say "Viewing %full at top of buffer for entire run"
    plot/bg/all ^{p1}_^{p2}_fstat y1=-5 y2=105
  endif

elseif function eqs "FAT" then
  homepath icefat
  if p1 eqss "E2D" or p1 eqss "T2D" then
    ask answer "**** Execute short pass [Y]/N :"
    if answer eqss "Y" %testmod/fab io ^p1 3 
    ask answer "**** Execute long pass [Y]/N :"
    if answer eqss "Y" %testmod/fab io ^p1 50 
  elseif p1 eqss "D2E" or p1 eqss "D2T" then
    ask answer "**** Execute short pass [Y]/N :"
    if answer eqss "Y" %testmod/fab oi ^p1 3 
    ask answer "**** Execute long pass [Y]/N :"
    if answer eqss "Y" %testmod/fab oi ^p1 50 
  elseif p1 eqss "PIC" or p1 eqss "MBT" then
    ask answer "**** Execute short pass [Y]/N :"
    if answer eqss "Y" %testcard/fab ^p1 3
    ask answer "**** Execute multituner view [Y]/N :"
    if answer eqss "Y" %testtuners/hs/c ^p1 3
    ask answer "**** Execute long pass [Y]/N :"
    if answer eqss "Y" %testcard/fab ^p1 50
    if answer eqss "Y" %testtuners/hs ^p1
  else
    say "Invalid card type = ^p1"
  endif
  homepath restore

elseif function eqs "PFAT" then
  homepath icefat
  if p1 eqss "E2D" or p1 eqs "D2E" or p1 eqs "A2D" then
    %testmod/noext/noxlink ix ^p1 5 pico
  else
    %testcard/noext/noxlink ^p1 5
    if /nox isfalse %testtuners/hs/c ^p1
  endif
  homepath restore

elseif function eqs "TACH" then
  picd/flags=test test ^p1 91

elseif function eqss "ATTACH" then
  picd/flags=test test ^p1 91
  picd/verbose/flags=force reset ^p1

elseif function eqs "MAKE"
  icemake,^p1,^p2,^p3

elseif function eqs "STATUS" then
  picd get ^p1 "STATUS" status
  picd get ^p1 "TYPE" ctype 
  if ctype eq 5 or ctype eq 6 then
    picd/node=0 ROUTE ^p1
    picd/node=0 TRS ^p1 /hex
  endif
  do nn 1 2
    picd get ^p1 "PMTYPE" pmtype /dmac=-nn
    if pmtype eq 0 continue
    picd/node=6+nn ROUTE ^p1 
    picd/node=6+nn TRS ^p1 /hex
  enddo

elseif function eqs "DMACX" then
  picd dmac ^p1
  icetest PPC/DMA ^p1

elseif "TEST/" subs function then
  sedit function function trim "TEST/"
  icetest,^function,^p1,^p2,^p3,^p4,^p5,^p6

elseif function eqs "FLASH" then
  error "Not supported under NextMidas. Use PICD LOADFLASH ..."

elseif function eqs "CHECKFLASH" then
  picd checkflash ^p1 /hex
  picd/node=0 get ^p1 type ctype
  picd/node=0 get ^p1 fpgasig sig /str
  sedit "nxm.ice.dat.icepic^{ctype}_^sig" fname locase strim
  key fname get "CRC" crc
  say "File ^fname ChkSum = ^crc"

else
  picdriver/quiet=0 , ^function , ^p1 , ^p2 , ^p3 , ^p4
endif

endmacro
