!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  SNAPPER Snapshot/Archive/Analysis macro for ICE cards
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
startmacro/msgid=main/mlog/stats=1/tll=128/tlt=.1 u:card u:cflags t:config

if config neqs "NULL" then
 res t:snapset config
else
 global snapset 
endif

res l:archiving 0
switch "AFLAGS" aflags get cflags
switch "RF" rcvr get "NONE" "ICE"
switch "RCVR" rcvr get rcvr "ICE"
switch "NIC" nic get "NONE" env.hostaddr
switch "TC" tcm get "NONE" "CPU"

! init settings
if snapset nrexists then
  set snapset {port=MODULE1,format=SB,rate=10,clock=N,length=1.0,dec=32,&
	freq=1,gain=0,mgain=0,nfft=1024,psdr=25,psda=5,expa=0,frame=512,wave=none,afname="archive"}
else
  if snapset.card rexists then set s:card snapset.card
  if snapset.aflags rexists then set s:aflags "^aflags|^snapset.aflags"
  if snapset.flags rexists then set s:aflags "^aflags|^snapset.flags"
  if snapset.mgain nrexists then  set snapset.mgain 0
  if snapset.expa  nrexists then  set snapset.expa  0
  if aflags eqss "|" sedit aflags aflags trim "|"
endif
if snapset.afqual nrexists then set s:snapset.afqual ""
if snapset.afkeys nrexists then set s:snapset.afkeys ""
if /dual and snapset.port eqss "MODULE" then
  set snapset.port "MODULE"
endif
sedit snapset.port lportc "RANGE" 0 0

! check card initialization status
res l:active -1
if /client isFalse then
  picd get card "ACTIVE" active
  if active lt 0 then
     say "Performing initial reset on card=^card"
     picd/flags=^aflags reset card
     picd get card "ACTIVE" active
  endif
endif

! init menus, plot list, and client macro switches
res otherband ""
if /tb gt 0 then		! tuner bank mode
  set l:ntbc 16
  if active ge 0 then
    picd/flags=^aflags get card "CHNS" ntbc
    if snapset.port neqs "TBANK3" res l:ntbc ntbc/2
  endif
  switch "TB" l:ntbc get,,ntbc	! use specified # channels
  if /dual then			! dual channel mode
    res ports "TBank"
    res plist "_CB1|_CB2"
    res cswitches "DUAL/TB=^ntbc"
    set snapset.port "TBANK"
  else
    res ports "TBank1,TBank2,TBank3"
    res plist "_CB"
    res cswitches "TB=^ntbc"
    if "TBANK" nsubs snapset.port set snapset.port "TBANK1"
  endif
elseif /dual then               ! dual channel mode
  res ports "Module,Tuner,TBank,Core,Core1,Core2"
  res plist "_CB1|_CB2|_CB1F|_CB2F|_CBXF"
  res cswitches "DUAL"
elseif /nbp then		! narrow band plot
  res ports "Module1,Module2"
  res plist "_CBF|_CBTF"
  res cswitches "NBP"
  res otherband "NarrowBandRam"
elseif /wbp then		! wide band plot
  res ports "Tuner1,Tuner2"
  res plist "_CBF|_CBTF"
  res cswitches "WBP"
  res otherband "WideBandRam"
elseif nic neqs "NONE" then	! network interface card
  res ports "Module1"
  res cswitches "NIC"
  res plist "_CB|_CBF"
elseif card eqs "NONE" then	! no ice card
  res ports "Module1,Tuner1"
  res cswitches "NOPIC"
  res plist "_CB|_CBF"
else				! default mode
  res ports "Module1,Module2,Module3,Tuner1,Tuner2"
  if active ge 0 then
    picd get card "PMTYPE1" value
    if value ne 0 res ports "^ports,Core1,Core2,MCore1,MCore2"
    picd get card "PMTYPE2" value
    if value ne 0 res ports "^ports,Pm2Tuner1,Pm2Tuner2,Pm2Core1,Pm2Core2,Pm2MCore1,Pm2MCore2"
  endif
  if /tsp then			! time series plots only
    res plist "_CB"
    res cswitches "TSP"
  else
    res plist "_CB|_CBF"
    res cswitches ""
  endif
endif
if /multi gt 0 then
  set ntbc (/multi)
endif
if /play then
  set function "Playback"
  set modes "Setup,RTMemory,OneShot,Exit,RTPlayback,DeArchive"
elseif /client gt 0 then
  set function "Monitor"
  set modes "Exit,DownLoad"
  set modes "Setup,RTMemory,Offline,Exit,RTArchive,DownLoad"
else
  set function "Acquire"
  set modes "Setup,RTMemory,OneShot,Exit,RTArchive,Archive"
endif
switch "MODES" modes get modes

! menu lists
res formats "SB,CB,SI,CI,SL,CL,SN,CN,SX,SP"
res rates   "1,2,3.125,5,6.25,10,12.5,20,25,30,40,50,60,64,70,80,90,100,&
		105,125,150,200,250,500,750,1000,1250,1500"
res lengths "0.1,0.25,0.5,1.0,2.0,5.0,10.0,20.0"
res clocks  "P-Program,PX-P/ExtRef,X-External,A-Module,B-Module,I-Int40/N,C-Crystal,D-Crystal/N,N-NoMuxClk"
res decs    "1,2,4,8,16,32,50,64,100,128,256,512"
res nffts   "256,512,1K,2K,4K,8K,16K,64K"
res affts   "1K,2K,4K,8K,16K,32K,64K"
res frames  "256,500,512,1000,1024,2048,4096,8192,16384"
res psdrs   "1,2,5,10,25,50"
res psdas   "1,2,5,10,25,50"
res waves   "None,White,LRS,Sine,Square,Tri,Saw,Ramp,TRamp,Zero,Const,MixLS,MuxLS,0xA55A,0xFFFF"
res rfbws   ".1,.5,1,2,5,10,20,25,40,50,60,80"
res deform  {M=SB,M3=CB,T=CI,C=SI}

if /pmfft then
res nffts   "256,512,1K,2K,4K"
res psdrs   "1,2,5,10,25,50,100,200"
res psdas   "1,2,4,8,16,32,64,128,256"
endif

! get the archive switches with defaults 
switch "ATL"   l:atl get 1M
switch "AAUX"  s:aux0 get aux.write
switch "AAUX1" s:aux1 get aux0
switch "AAUX2" s:aux2 get aux0
switch "RAUX"  s:raux get "^aux1|^aux2"
sedit aux.read auxes append "|" append raux gsubs "|" ","

! local state variables
res s:rclock "Z"	! clock at reset
res s:afn "NULL"	! archive file name
res l:ptl 64k		! practical transfer length
res d:mfl 0		! multiple file length
res d:mfw 0		! multiple file wrap
res ofb "F"		! output Float/Byte format for PSDs
set l:filesAreOk 0	! keeps track of need to recreate ICE disk files
set d:scale 128		! this must be adjusted before data reaches the time plotter
calc fscale scale log 10 *
timex now sec=timecode
res apktdef "OFF"
if tcm neqs "NONE" set apktdef "ON"
switch "LTYPE" ltype get "LINE"

! status logger
sedit "snapper_^{card}_^{snapset.port}" logfn "LOCASE"
if /client gt 0 then res logfn "OFF"
switch "MLOG" s:logfn get "OFF" logfn
if logfn neqs "OFF" then report on logfn

pipe on

if /client gt 0
  env get "SERVER" remote
  rmif/prange=5 /client ,, {ID=ICESRV,HP=^remote} q:ack|^plist
  if aux0 neqs aux.write set aux.^aux0 "http://^remote/Files/^aux0/"
  if aux1 neqs aux0      set aux.^aux1 "http://^remote/Files/^aux1/"
  if aux2 neqs aux0      set aux.^aux2 "http://^remote/Files/^aux2/"
elseif /server gt 0
  rmif/http ^/server ^plist
  system/id=sys disk /pause=5
  set cswitches "^cswitches/AAUX=^aux0"
  if aux1 neqs aux0 then set cswitches "^cswitches/AAUX1=^aux1"
  if aux2 neqs aux0 then set cswitches "^cswitches/AAUX2=^aux2"
else
  system/id=sys disk /pause=5
endif
if /server gt 0 or /rtppsd neqs "NULL" then
  set ofb "B"
endif

if /headless then
  panel/controls=gc	! this will inherit the headless switch and not show

elseif /tb gt 0 or /multi gt 0 then			! multi channel plots
  res l:mcf 256
  if ntbc gt 256 res l:mcf 64
  if /dual then
    panel/setup=tb2/controls=gc/logger
    plot/id=tdlp1 _cb1 view=iyx axis=frame layer={LT="nxm.ice.libg.LayerMC",&
	TYPE=LINE,PROCESS=RAW,NFFT=mcf,NCHAN=gc.NTBC.v,MIN=-32k,MAX=32K,MINRANGE=100}
    plot/id=fdrp1 _cb1 view=iyx axis=frame layer={LT="nxm.ice.libg.LayerMC",&
	TYPE=RAST,PROCESS=FFT,NFFT=mcf,NCHAN=gc.NTBC.v,MAX=20,MIN=-40}
    plot/id=tdlp2 _cb2 view=iyx axis=frame layer={LT="nxm.ice.libg.LayerMC",&
	TYPE=LINE,PROCESS=RAW,NFFT=mcf,NCHAN=gc.NTBC.v,MIN=-32k,MAX=32K,MINRANGE=100}
    plot/id=fdrp2 _cb2 view=iyx axis=frame layer={LT="nxm.ice.libg.LayerMC",&
	TYPE=RAST,PROCESS=FFT,NFFT=mcf,NCHAN=gc.NTBC.v,MAX=20,MIN=-40}
  else
    panel/setup=tb/controls=gc/logger
    plot/id=tdlp _cb view=iyx axis=frame layer={LT="nxm.ice.libg.LayerMC",&
	TYPE=LINE,PROCESS=RAW,NFFT=mcf,NCHAN=gc.NTBC.v,MIN=-32k,MAX=32K,MINRANGE=100}
    plot/id=fdrp _cb view=iyx axis=frame layer={LT="nxm.ice.libg.LayerMC",&
	TYPE=RAST,PROCESS=FFT,NFFT=mcf,NCHAN=gc.NTBC.v,MAX=40,MIN=-40}
  endif

elseif /tsp then					! time series plots
  if /dual then
    panel/setup=t2/controls=gc/logger
    plot/id=tdlp _cb1{cl=4}|_cb2{cl=4} type=ltype y1=-scale y2=scale
    plot/id=tdrp1 _cb1 type=rast 
    plot/id=tdrp2 _cb2 type=rast
  else
    panel/setup=t/controls=gc/logger
    plot/id=tdlp _cb{cl=4} type=ltype y1=-scale y2=scale
    plot/id=tdrp _cb type=rast readout=+T
  endif

else							! freq series plots
  if /tivo then
    panel/setup=tvo/controls=gc/logger
  elseif /fdp then
    panel/setup=f/controls=gc/logger
  else
    panel/setup/controls=gc/logger
  endif
  if /dual then
    plot/id=tdlp _cb1{cl=4}|_cb2{cl=4}   type=ltype y1=-scale y2=scale 
    plot/id=fdlp _cb1f|_cb2f type=line axis=trframe ymax=fscale
    plot/id=fdrp _cbxf       type=rast axis=brframe zmax=fscale cm=10log readout=+T
  else
    if /nbp or /wbp then
      plot/id=tdlp _cbtf type=line axis=trframe 
    elseif /fdp isfalse then
      plot/id=tdlp _cb{cl=4}  type=ltype y1=-scale y2=scale 
    endif
    plot/id=fdlp _cbf type=line axis=trframe ymax=fscale
    plot/id=fdrp _cbf type=rast axis=brframe zmax=fscale readout=+T 
  endif
  set reg.fdlp.mimic fdrp	! tie PAN/ZOOM messages
  set reg.fdrp.mimic fdlp
  if /client gt 0 then		! set RMIF compression handlers (comp=plot)
    set reg.fdlp.rmif "RMIF"
    if /nbp or /wbp then set reg.tdlp.rmif "RMIF"
  endif
  if /nbp then
    set reg.win.tdlp.title "NarrowBand PSD"
    set reg.win.fdlp.title "WideBand PSD"
    feature ,, ff {NAME=FF,TYPE=VLINE|DATA,COLOR=RED} fdlp
  elseif /wbp then
    set reg.win.tdlp.title "WideBand PSD"
    set reg.win.fdlp.title "NarrowBand PSD"
    feature ,, ff {NAME=FF,TYPE=VLINE|DATA,COLOR=RED} tdlp
  else
    feature ,, ff {NAME=FF,TYPE=VRIDE|SYMBOL,SYMBOL=CIRCLE,COLOR=RED} fdlp
  endif
endif

  gcontrol label  "FUNC"   function
  gcontrol button "MODE"   "" modes "Setup" /nc=2
  gcontrol choice "WAVE"   "Waveform" waves snapset.wave /input
  gcontrol tval   "TIME"   "TC" timecode 1 -1 1  /edit=f /mon=reg.sp.time.sec
if /emt gt 0
  gcontrol lval   "EMT"    "Loading" 0 0 128 1  /edit=f /guage
endif
if /play then
  gcontrol dval   "DELAY"   "Delay" 0.2 0 snapset.length .1 
endif
if /marker then
  gcontrol dval   "QFREQ"   "MrkFreq" 0 1 -1 1 /fmt="#0.000" /units="MHz" /edit=f
endif

  gcontrol label  "ARCH"   "Archive" 0
  gcontrol file   "AFNAME" "File" snapset.afname ,, raux
  gcontrol tval   "ATCT"   "Top" 0 1 -1 1  /edit=f
  gcontrol tval   "ATCL"   "Len" 0 0 1 1  /edit=f /flags=max 
  gcontrol lval   "AUXU"   "Disk" 0 0 100 1 /gauge /units="% Full" /edit=f
  gcontrol tval   "ATCA"   "Available" 0 1 -1 1  /edit=f 

if /sdds or nic neqs "NONE" then
  if snapset.vlan nrexists call addToSet {VLAN=0,ADDR="224.0.0.0"}
  gcontrol label  "SDDS"   "SDDS Config"
  gcontrol lval   "VLAN"   "SDDS VLan" snapset.vlan 0 32k-1 1
  gcontrol prompt "ADDR"   "SDDS Addr" snapset.addr
endif

if rcvr neqs "NONE"
  if snapset.rffreq nrexists call addToSet {RFFREQ=1000,RFGAIN=0,RFATTN=0,RFBW=40,RFOPTS=|}
  gcontrol label  "RCVR"   "RF Config"
  invoke rfoptslist=nxm.ice.lib.DevIce.rfOptsList 
  gcontrol dval   "RFFREQ" "RF Freq" snapset.rffreq 0 10000 1 /fmt="#0.000" /units="MHz" ! (10.7,21.4,70,140,200)
  gcontrol choice "RFBW"   "RF BW  " rfbws s:snapset.rfbw /units="MHz" /input
  gcontrol lval   "RFATTN" "RF Attn" snapset.rfattn 0 100 1 /units="dB"
  gcontrol lval   "RFGAIN" "RF Gain" snapset.rfgain 0 75 1 /units="dB"
  gcontrol lval   "RFPWR"  "RF Pwr " 0 -100 1020 1 /units="dB" /edit=f
  gcontrol choice "RFOPTS" "RF Opts" rfoptslist snapset.rfopts /toggle 
  set cswitches "^cswitches/RCVR"
endif

  gcontrol label  "CFG"    "Port Config"
  gcontrol prompt "CARD"   "Card  "  card 
  gcontrol choice "PORT"   "Port  "  ports snapset.port /input
  gcontrol choice "FORMAT" "Format"  formats snapset.format
  gcontrol choice "RATE"   "Rate  "  rates s:snapset.rate /units="MHz" /input
  gcontrol choice "LENGTH" "Length"  lengths s:snapset.length /units="sec" /input
  gcontrol choice "CLOCK"  "Clock "  clocks snapset.clock
  gcontrol choice "DEC"    "Dec   "  decs s:snapset.dec /input
  gcontrol dval   "FREQ"   "Freq  "  ^snapset.freq -.5*gc.RATE.v gc.RATE.v 1 /fmt="#0.000" /units="MHz" /slider
  gcontrol lval   "GAIN"   "Gain  "  ^snapset.gain -100 100 1 /units="dB" /slider
  gcontrol lval   "MGAIN"  "MGain "  ^snapset.mgain -100 100 1 /units="dB" /slider

if /tb gt 0 or /multi gt 0 then
  if snapset.chan nrexists call addToSet {CHAN=0,TBCS=-1}
  gcontrol lval   "CHAN"   "IChn  "  snapset.chan -1 ntbc 1
  gcontrol choice "NTBC"   "NChn  "  "1,2,4,8,16,32,64,128,256,1000,1024,2000,2048,4000,4096" "^ntbc" /input
  gcontrol dval   "TBCS"   "ChnSp " snapset.tbcs -1 1e6 1 /units="Hz"
endif

  gcontrol label  "DISP"   "Displays" 
  gcontrol choice "FRAME"  "Frame Size" frames s:snapset.frame /input
  gcontrol choice "NFFT"   "Fft Size  " nffts s:snapset.nfft /input
  gcontrol choice "PSDR"   "Disp Rate " psdrs s:snapset.psdr /units="Hz" /input
  gcontrol choice "PSDA"   "Disp Avg  " psdas s:snapset.psda /units="Frames" /input
  gcontrol lval   "EXPA"   "Expn Avg  " l:snapset.expa 0 100 1 /units="Frames"
  gcontrol dval   "SCALE"  "Max Scale " 0 1 1e19 128 
  gcontrol choice "MONM"   "Monitor   " "Off,Async,Info,Full" "Async"
if /fixrange gt 0
  gcontrol lval   "RANGE"  "PSD Range " /fixrange 10 200 10
endif

  gcontrol label  "ANAL"   "Analysis" 0
  gcontrol choice "AMODE"  "Source " "Ram,Disk,DownLoad,ReadAfterWrite,^otherband" "Ram"
  gcontrol choice "DMOD"   "Demod  " "None,AM,FM,PSK,QPSK,SQUARE,FOURTH" "NONE"
  gcontrol choice "AUDIO"  "Audio  " "None,JMF,RTP" "NONE"
  gcontrol choice "AFFT"   "FftSize" affts "4K" /input
  gcontrol button "APLOT"  "" "Function,Datalist,BufStats,Status" /nc=2 
  gcontrol dval   "APGR"   "Progress" 0 0 1 .1 /gauge 

  gcontrol label  "OPTS"   "Options" 0
  gcontrol prompt "FLAGS"  "Flags  " aflags
  gcontrol prompt "AFQUAL" "AFQual " snapset.afqual
  gcontrol prompt "AFKEYS" "AFKeys " snapset.afkeys
  gcontrol choice "ATAG"   "ArchTag" "None,Date,MJS" "None"
  gcontrol choice "AOVER"  "Overlay" "Ask,Erase,OverWrite,Append,LeaveAlone,Abort" "Ask"
  gcontrol choice "HDR"    "Headers" "Attached,Detached" "Det"
  gcontrol choice "APKT"   "Packets" "On,Off,SDDS,SDDS/DET" apktdef
  gcontrol lval   "STATS"  "Stats  " /stats 0 60 1
  gcontrol choice "COMP"   "Compression" "Off,Data,Plot" "Plot"

  gcontrol label  "SYS"    "System" 0
if /dual then
  gcontrol choice "AUX1"   "Disk Aux-1 " auxes aux1 /edit=n
  gcontrol choice "AUX2"   "Disk Aux-2 " auxes aux2 /edit=n
  gcontrol lval   "AUX1U"  "Disk Used-1" 0 0 100 1 /gauge /edit=n
  gcontrol lval   "AUX2U"  "Disk Used-2" 0 0 100 1 /gauge /edit=n
else
  gcontrol choice "AUX0"   "Disk Aux-0 " auxes aux0 /edit=n
  gcontrol lval   "AUX0U"  "Disk Used-0" 0 0 100 1 /gauge /edit=n
endif
  gcontrol lval   "FULL"   "DiskFullAt " 98 0 100 1 /gauge
  gcontrol dval   "MAXFS"  "MaxFileSize" 2000G 1M 64T 1M /units="by"
  gcontrol lval   "CPU"    "Total CPU  " 0 0 100 1 /gauge
  gcontrol lval   "LOST"   "LostBuffers" 0 1 -1 1  /edit=f
  gcontrol lval   "CYCLE"  "CurrCycle" 0 1 -1 1  /edit=f /mon=reg.sp.cycle
  gcontrol pipe   "PMON"   "Pipes" 

if /dbg then
  gcontrol label  "DBG"    "Debug" 0
  gcontrol button "DBGACT"  "Action" "RPM,WPM,RPB,WPB,RPC,WPC" /nc=3 /tleft
  gcontrol choice "DBGPRT"  "Port  " "IOModule1,IOModule2,Core1,Core2,HyperLink1,HyperLink2,ProcModule1,ProcModule2" /idef=1
  gcontrol lval   "DBGOFF"  "Offset" 0 0 64K 1 /hex
  gcontrol lval   "DBGVAL"  "Value " 0 1 -1 1 /hex
  gcontrol lval   "DBGRSZ"  "Size " 1 1 4 1 
endif

if /tivo gt 0 then 			! setup tivo raster 
  calc cfl /tivo 60 max
  res cswitches "^cswitches/TIVO=^cfl"
  if /headless isfalse then 
    plot/id=tvrp type=rast axis=frame options=+BS readout=+T
    set reg.panel.toggleborders 0x2
  endif
  gcontrol label  "TIVO"  "TiVo FD Raster" 
  gcontrol button "TIVOM" "" "<<,<,RT,>,>>" "RT" /onerow 
  gcontrol tval   "TIVOS" "Bottom" 0 1 -1 1 
  gcontrol choice "TIVOL" "Window" "All,1:00,5:00,10:00,1:00:00,2:00:00" "1:00" /input
else
  switch "CFL" d:cfl get 0		! circular file length
endif

if /cross then
  gcontrol label  "CROSS"  "Cross Correlation" 
  gcontrol panel  "CPLOT" "" 200 100
  plot/id=cplot _cbxf type=point cm=phase y1=-180 y2=180 axis=frame
  set gc.DISP.action close
endif

if /checktc then erase dumptcstat dumptcdata

if /tsp then set gc.NFFT.show 0
call picspecs
call checkafname
call setformat "SET"
call setport
call setdec

pipe off

! save off settings
if config eqs "NULL" and cflags eqs "" and aflags neqs "" then
  set snapset.flags ""
endif
foreach item intable snapset
  if gc.^item rexists set snapset.^item gc.^{item}.value
endfor

! clean up ramdisk files
foreach item inlist "ramfile,ramfile1,ramfile2,ramfilet,ramfilec" 
  if /clean neq 0 and ^item rexists erase/warn=off ^item
endfor
if logfn neqs "OFF" then report off

endmacro

procedure open
if /client gt 0 then
  set t:sets {} 
  foreach key intable gc
    set sets.^key "?"
  endfor
  message send "ICESRV" ,, "GET" ,, sets
elseif gc.MODE.v neqs "SETUP" then
  set gc.MODE.action gc.MODE.v
endif
if /play lt 0 and card neqs "NONE" then set gc.WAVE.show 0
if /tivo gt 0 then set gc.CFG.v "CLOSED"
if /client isfalse then
  set this.timers 2
  set this.timer(0) 1
  set this.timer(1) 10
  sendto main "TIMER" info=1
endif
return

procedure close
if gcalert rexists pause 1
while reg.noop rexists
  warning "Waiting on NOOP process"
  pause 1
endwhile
return

procedure processMessage m:msg

!say "Got message ^msg.name = ^msg.data from ^msg.fid"

if msg.name eqs "CYCLE" then
  if msg.data eq 1 and "ONE" subs gc.MODE.v then 
    if autoarchive then
      set gc.MODE.action "ARCHIVE"
    else
      set gc.MODE.action "SETUP"
    endif
  endif

elseif msg.name eqs "TIMER" and msg.info eq 0 then  ! 1 sec
  if reg.sp rexists then
    if /checktc then call dumptcdata
  endif
  if tvfn rexists and gc.TIVOM.v eqs "RT" and gc.TIME.v-gc.TIVOS.v gt 60 then
    call refreshTivoPlot
  endif
  if /server gt 0 then message send rmif ,, "ACK" ,, {TIME=^gc.TIME.v}
  if afn neqs "NULL" and afn fexists and /client isFalse then
    status afn timeAt(0)=gc.ATCT.v len=gc.ATCL.max xd=delta
    if reg.sp rexists then set gc.ATCL.v reg.sp.offset*delta 
    if /server gt 0 then message send rmif ,, "ACK" ,, {ATCT=^gc.ATCT.v,ATCL=^gc.ATCL.v}
  endif
  if gc.RFPWR rexists and reg.sp rexists and card neqs "NONE" then
    picd/flags=aflags/port=port1 get card "RFPWR" gc.RFPWR.v
  endif
  if /emt gt 0 and card neqs "NONE" then
    picd/flags=aflags/port=port1 get card "EMT" gc.EMT.v
  endif
  if archiving neq 0 and reg.NOOP nrexists then
   if archiving lt 0 then
    calc d:rate 1 file(ramfile).xd / round 1e-6 *
    set gc.RATE.v ^rate
    set gc.LENGTH.v file(ramfile).length
    set gc.MODE.v "SETUP"
    set gc.WAVE.v "File"
    set l:filesAreOk 1
   else
    if gc.APKT.v neqs "SDDS" then 
    elseif archiving eq 2
     keyword ^{gc.AFNAME.v}_1{AUX=^AUX1} put "PACKET" "SDDS/ICE" /scope=main
     keyword ^{gc.AFNAME.v}_2{AUX=^AUX2} put "PACKET" "SDDS/ICE" /scope=main
    else
     keyword gc.AFNAME.v{AUX=^AUX0} put "PACKET" "SDDS/ICE" /scope=main
    endif
    set gc.AMODE.v "DISK"
   endif
    set gc.MODE.action "SETUP"
    set l:archiving 0
  endif

elseif msg.name eqs "TIMER" and msg.info eq 1 then  ! 10 sec
  report flush
  if /tivo gt 0 and /headless isfalse and tvfn nrexists then
    call refreshTivoPlot
    call updateFreqMarker
  endif
  if /gps gt 0
    picd "GPS" ^card ,, gps /dmac=-(/gps)
  endif

elseif msg.fid eqs "FDLP" or msg.fid eqs "FDRP" or msg.fid eqs "TDLP" or msg.fid eqs "TDRP" then
  ! forget marrying windows for now
  if msg.name eqs "MARK" and gc.MODE.value eqss "RT" then
    if /tb or /multi then		! click select
      set layer reg.^{msg.fid}.layers._cb
      set layer.select msg.data
      set gc.CHAN.action layer.select+1
    elseif msg.fid eqss "FD" then	! click tune
      set d:freq msg.data.x*1e-6
      if /nbp then set gc.FREQ.action freq
      if ff rexists set ff.x msg.data.x
      call updateFreqMarker
    elseif msg.fid eqss "TD" then	! click tune
      set d:freq msg.data.x*1e-6
      if /wbp then set gc.FREQ.action freq
    endif
  endif

elseif msg.fid eqs "TVRP" then
  if msg.name eqs "ZOOM" then
    set gc.TIVOM.v "NONE"  ! turn off RealTime
  elseif msg.name eqs "MARK" then
    set gc.TIVOS.value msg.data.t
  endif

elseif msg.fid eqs "RMIF" then		! handle server/client messaging
  if msg.name eqs "OPEN"
    info "Got open ^msg.data from ^msg.fid"
  elseif msg.name eqs "OPENED"
    info "Got opened ^msg.data from ^msg.fid"
    pause 0.5  ! make sure plots are up
    set gc.COMP.action "PLOT"
  elseif msg.name eqs "CLOSE"
    info "Got close ^msg.data from ^msg.fid"
  elseif msg.name eqs "CLOSED"
    info "Got closed ^msg.data from ^msg.fid"
  endif

elseif msg.name eqs "GET" then		! server side
  set t:sets msg.data
  foreach key intable sets
    set sets.^key gc.^{key}.value
  endfor
  message send "REPLY" msg "RET" ,, sets

elseif msg.name eqs "RET" then		! client side
  set t:sets msg.data
  foreach key intable sets
    if key eqss "TIVO" then 
      ! TIVO messages handled locally
    else
      set gc.^{key}.value "^sets.^key"
      if key eqs "FREQ" call updateFreqMarker
      if key eqs "SCALE" call updateScale
    endif
  endfor

elseif msg.name eqs "SET" then		! server side
  set t:sets msg.data
  foreach key intable sets
    if key eqss "TIVO" then 
      ! TIVO messages handled locally
    elseif key eqs "JOIN" or key eqs "IPCONN" then
      set reg.SP.join "^sets.^key"
    elseif key eqs "LEAVE" or key eqs "IPDISC" then
      set reg.SP.leave "^sets.^key"
    elseif key eqs "VLAN" or key eqs "IPVLAN" then
      set reg.SP.vlan "^sets.^key"
    elseif key eqs "INFO" then
      info sets.^key
    else
      set gc.^{key}.action "^sets.^key"
    endif
  endfor
  message send "REPLY" msg "ACK" ,, sets

elseif msg.name eqs "ACK" then		! client side
  set t:sets msg.data
  foreach key intable sets
    if key eqs "SYSTEM" then
      call picsystem sets.SYSTEM
    elseif key eqss "TIVO" then
      ! TIVO messages handled locally
    else
      set gc.^{key}.value "^sets.^key"
      if key eqs "FREQ" call updateFreqMarker
      if key eqs "SCALE" call updateScale
    endif
  endfor

elseif msg.name eqs "EXIT"
  pipe stop

elseif msg.name eqs "SYSTEM"
  call picsystem msg.data
  if /server gt 0 then message send rmif ,, "ACK" ,, {SYSTEM=^msg.data}

elseif msg.name eqs "TIVOM" then
  if msg.data eqs "RT" then
    calc tv ^gc.TIME.v
    set gc.TIVOM.v "RT"
  elseif gc.TIVOL.v eqs "ALL" then
    calc tv ^gc.TIME.v
  elseif msg.data eqs ">" then
    calc tv gc.TIVOS.v ^gc.TIVOL.v 4 / +
  elseif msg.data eqs "<" then
    calc tv gc.TIVOS.v ^gc.TIVOL.v 4 / -
  elseif msg.data eqs ">>" then
    calc tv gc.TIVOS.v ^gc.TIVOL.v +
  elseif msg.data eqs "<<" then
    calc tv gc.TIVOS.v ^gc.TIVOL.v -
  endif
  set gc.TIVOS.action ^tv

elseif msg.name eqs "TIVOS" then
  call refreshTivoPlot

elseif msg.name eqs "TIVOL" then
  call refreshTivoPlot

elseif msg.name eqs "DOWNLOAD" then
  if aux.write eqs "RAM" then
    gc/temp/msg=n alert "TEMP" "Download" "DownLoad not available from Applet - try WebStart"
    return
  endif
  set dlfn msg.data.FNAME.v
  set ulfn "^{gc.AFNAME.v}.tmp(~^msg.data.START.v:+~msg.data.LENGTH.v)"
  noop/bg/gpw/tl=1m http://^remote/Files/^ulfn dlfn
  set gc.ANAL.action "OPEN"
  set gc.AMODE.v "DOWNLOAD"

elseif msg.name eqs "APLOT" or msg.name eqs "OPLOT"
  ! handle special cases
  if msg.name eqs "OPLOT" then
    if msg.data nsubs gc.APLOT.items then
!       set gc.APLOT.items "^gc.APLOT.items,^msg.data"
       set gc.APLOT.items "Function,Datalist,^msg.data,Status"
    endif
  elseif msg.data eqs "FUNCTION"
    set tmp "TD-Line,TD-Raster,TD-Phase,FD-Line,FD-Raster,FD-Phase,Histogram,DataList"
    set tmp "^tmp,TimeCode,Packets,BitStats,LSBit,Logs,SDDS-Info,SDDS-Gap,DualDiff,DMAC,DMACX,BufStats,Status"
    gc/temp button "OPLOT"  "Analysis Functions" tmp /nc=2
    return
  endif
  if msg.data eqs "BUFSTATS"
    if /client gt 0
      gc/temp/msg=n alert "TEMP" "Analyze" "STATS plot not available in client mode"
    elseif /dual then
      call picfstats "SP"
      call picfstats "SPS"
    else
      call picfstats "SP"
    endif
  elseif msg.data eqs "LOGS"
    if logfn eqs "OFF" then
      gc/temp/msg=n alert "TEMP" "Logs" "Logging is turned OFF"
    else
      report flush
      list/bg ^{logfn}.mlog
    endif
  elseif msg.data eqs "STATUS"
    pic/flags=aflags STATUS card
  elseif msg.data eqs "DMAC"
    picd/flags=aflags DMAC card
  elseif msg.data eqs "DMACX"
    pic/flags=aflags DMACX card
    return
  else
    set analist "0"
    if /dual then set analist "1,2"
 foreach ext inlist analist
  ! prepare the data file
  if ext eqs "0" then set ext ""
  if gc.AMODE.v eqs "RAM" then
    set alfn ramfile^ext
  elseif gc.AMODE.v eqs "NARROWBANDRAM" or gc.AMODE.v eqs "WIDEBANDRAM" then
    set alfn ramfilet
  elseif gc.AMODE.v eqs "DISK" or gc.AMODE.v eqs "READAFTERWRITE" then
    if afn eqs "NULL" 
      set alfn gc.AFNAME.v
    else
      set alfn afn
    endif
    if ext neqs "" then set alfn ^{alfn}_^ext
  elseif gc.AMODE.v eqs "DOWNLOAD" then
    if dlfn nrexists then
      gc/temp alert "ANALYZE" "Analyze" "DownLoad must precede Analysis Options"
      return
    endif
    set alfn dlfn
  endif
  set snaptmp "snaptmp^ext"	! temporary file
  if gc.AMODE.v eqs "READAFTERWRITE" and msg.data nsubs "STATUS|PACKETS|TIMECODE"
    set alfn "^{alfn}(-~1:)"
  endif
  if alfn nfexists then
    gc/temp alert "ANALYZE" "Analyze" "Analyze File ^alfn does not exist"
  elseif msg.data eqs "STATUS"
    status/k alfn
  elseif msg.data eqs "DATALIST"
    calc nc 16 file(alfn).bpe 1 max /
    data/hex/nc=nc/h alfn{fs=0} 0 gc.AFFT.v/16
  elseif msg.data eqs "PACKETS"
    if file(alfn).ext.key(packet) eqs "SDDS/ICE" then
      do n 0,8k,1k
        datalist/p alfn n +4
      enddo
    elseif ^{alfn}.pkt fexists then
      list2/mod/bg ^{alfn}.pkt
    else
      warn "No SDDS or ICE packets modes found"
    endif
  elseif msg.data eqs "TIMECODE"
    if file(alfn).ext.key(packet) eqs "SDDS/ICE" then
      icetc extract "SDDS" alfn snaptmp /test
      list2/mod/bg snaptmp
    elseif ^{alfn}.pkt fexists then
      icetc extract "ICE" ^{alfn}.pkt snaptmp /test /delta=file(alfn).delta
      list2/mod/bg snaptmp
    else
      warn "No SDDS or ICE packets modes found - listing TC hack +-16 samples"
      set tc file(alfn).time
      calc offset 1-tc.fsec file(alfn).xdelta / round
      data/hex/nc=8 alfn offset-16 +32
      calc offset offset-1000 0 max
      plot/bg alfn(offset:+2000)
    endif
  elseif msg.data eqs "SDDS-INFO"
    picd/flags=aflags/port=port get card "PKTHDR" /hex /verbose
    picd/flags=aflags/port=port get card "GAP" gap
    calc gap 0xFFFF band =l:gapmin gap 64k / =l:gapmax
    say "SDDS Packet Gap Min=^gapmin Max=^gapmax uS"
    picd/flags=aflags/port=port get card "SEQFILL" seqfill
    picd/flags=aflags/port=port get card "SEQERR" seqerr
    say "SDDS Sequence Fill=^seqfill Err=^seqerr"
    picd/flags=aflags/port=port get card "DUMP" sdump
  elseif msg.data eqs "SDDS-GAP"
    call picgstats "SP"
  elseif msg.data eqs "CALCAIS"
    iceais ^{alfn}(0:1M) aistaps
    info "Ais TAPS=^aistaps"
    picd/flags=aflags/port=port set card "RFAIS" aistaps
  elseif msg.data eqs "DUALDIFF"
    icediff ramfile1 ramfile2
  else
    call analyze msg.data alfn snaptmp
  endif 
 endfor
  endif

elseif msg.fid eqs "APLOT"
  ! ignore messages from analysis plots

elseif msg.name eqs "COMP" then
  set reg.fdlp.compression msg.data
  if /nbp or /wbp then set reg.tdlp.compression msg.data

elseif msg.name eqs "SCALE"
  call updateScale

elseif msg.name eqs "RANGE"
  call setRange

elseif /client gt 0	
  if msg.data eqs "EXIT" then
    pipe stop
  elseif msg.data eqs "ONLINE" then
  elseif msg.data eqs "OFFLINE" then
  elseif msg.data eqs "DOWNLOAD" then
    if dlfn nrexists set dlfn "myfile"
    if /tivo gt 0 then
      calc d:tcs reg.TVRP.t1 10 * round 10 /
      calc d:tcl reg.TVRP.y2-reg.TVRP.y1 10 * round 10 /
      calc d:fw reg.TVRP.x2-reg.TVRP.x1 round
      calc d:fc reg.TVRP.x1+(fw/2) round
    else
      set d:tcs gc.ATCT.value
      set d:tcl 10.0
      set d:fc 0
      set d:fw 1e6*gc.RATE.v/2
    endif
    gc/temp/handle=dlog dialog "DOWNLOAD" "DownLoad ARCH=^gc.AFNAME.v" 300 -5
    gc/panel=dlog tval   "START"   "TimeStart" tcs 1 -1 1
    gc/panel=dlog choice "LENGTH"  "Duration " "1,2,5,10,30,1:00,2:00,5:00,10:00" "^tcl" /units="sec" /input
    gc/panel=dlog dval   "FCENTER" "FreqCenter" fc 1 -1 1000 /units="Hz"
    gc/panel=dlog dval   "FWIDTH"  "FreqWidth " fw 1 -1 1000 /units="Hz"
    gc/panel=dlog prompt "FNAME"   "ToFile" dlfn
  else 
    ! client GUI sends all other GC messages to server
    message send "ICESRV" ,, "SET" ,, {^msg.name=^msg.data}
  endif

elseif msg.name eqs "MODE"
  if msg.data eqss "START."
    sedit msg.data msg.data "TRIM" "START."
    call picstart msg.data
    call picwait 20
    return
  endif
  set afn "NULL"
  if msg.data eqs "SETUP" or msg.data eqs "STOP" then
    call picstop
    set gc.MODE.v "SETUP"
    if /autoexit then pipe stop
  elseif archiving gt 0 then
    warn "Archive not complete.  Use progress widget to cancel."
    set gc.MODE.v "ARCHIVE"
  elseif archiving lt 0 then
    warn "Dearchive not complete.  Use progress widget to cancel."
    set gc.MODE.v "DEARCHIVE"
  elseif msg.data eqs "EXIT"
    pipe stop
  elseif "ONE" subs msg.data or msg.data eqs "WAVEFORM"
    call picstop
    call picsetup
    switch "AUTOARCHIVE" autoarchive get test(ARCH,SUBS,msg.data)
    set gc.MODE.v "ONESHOT"
    if msg.info ge 0 call picstart "ONE"
  elseif msg.data eqs "DEARCHIVE" 
    if ramfile nrexists sedit "^{gc.CARD.value}_^{gc.PORT.value}" ramfile "UPCASE"
    noop/bg/gpw gc.AFNAME.v ramfile{AUX=ENV.RAMAUX,DET=1,CTG=1}
    set l:archiving -1
  elseif msg.data eqs "ARCHIVE" 
    if reg.sp rexists and reg.sp.replay neqs "STOPPED" then
      gc/temp/timeout=2 alert ,,, "Must stop current acquisition/playback first."
      set gc.MODE.action "SETUP"
    elseif /dual then
      info "Archiving ^ramfile1 to ^{gc.AFNAME.v}_1"
      noop/bg/gpw ramfile1 ^{gc.AFNAME.v}_1{AUX=^AUX1,DET=^gc.HDR.item-1}
      info "Archiving ^ramfile2 to ^{gc.AFNAME.v}_2"
      noop/bg/gpw ramfile2 ^{gc.AFNAME.v}_2{AUX=^AUX2,DET=^gc.HDR.item-1}
      set l:archiving 2
    else
      info "Archiving ^ramfile to ^gc.AFNAME.v"
      noop/bg/gpw ramfile gc.AFNAME.v{AUX=^AUX0,DET=^gc.HDR.item-1}
      set l:archiving 1
    endif
  elseif msg.data eqss "RT" or msg.data eqss "MON" or msg.data eqss "REC" or msg.data eqss "PLAY" then
    call picstop
    if "MEM" subs msg.data or "MON" subs msg.data then
      set gc.MODE.v "RTM"
      set gc.AMODE.v "RAM"
    else
      set afn gc.AFNAME.v
      timex now curtime
      if /play then
        set gc.MODE.v "RTP"
        info "DeArchiving from ^afn"
      else
        set gc.MODE.v "RTA"
        if gc.ATAG.v eqs "DATE" set afn "^{afn}_^curtime.tofilename"
        if gc.ATAG.v eqs "MJS" set afn "^{afn}_^l:curtime.getmjs"
        info "Archiving to ^afn"
      endif
      if gc.AMODE.v eqs "RAM" set gc.AMODE.v "READ"
    endif
    call picsetup
    if msg.info ge 0 call picstart "CONT"
  endif

elseif msg.name eqs "ANALYZE"
  say "Got an abort message"

elseif msg.name eqs "PORT" or msg.name eqs "WAVE"
  call setport
  call picrestart

elseif msg.name eqs "CARD"
  res rclock "Z"	! trigger reset
  call picrestart

elseif msg.name eqs "FLAGS"
  set aflags gc.FLAGS.v
  res rclock "Z"	! trigger reset
  call picrestart

elseif msg.name eqs "LENGTH"
  if /play then set gc.DELAY.max ^gc.LENGTH.value
  call picrestart

elseif msg.name eqs "FRAME" or msg.name eqs "NFFT" or msg.name eqs "CLOCK"  &
    or msg.name eqs "ADDR"  or msg.name eqs "PSDR" or msg.name eqs "PSDA"   &
    or msg.name eqs "VLAN"  or msg.name eqs "NTBC" or msg.name eqs "TBCS"  then
  call picrestart

elseif msg.name eqs "FORMAT" or msg.name eqs "DEC" then 
  call setformat "SET"
  call setdec
  call picrestart

elseif msg.name eqs "RATE"
  set gc.FREQ.min -.5*gc.RATE.v
  set gc.FREQ.max gc.RATE.v
  call setdec
  call picrestart

elseif msg.name eqs "FREQ"
  set d:freq msg.data
  calc dfreq freq 1e6 *
  if reg.sp rexists set reg.sp.freq dfreq
  if reg.sps rexists set reg.sps.freq dfreq
  if reg.spt rexists set reg.spt.freq dfreq
  if /server then message send rmif ,, "ACK" ,, {FREQ=^freq}
  call updateFreqMarker
  if wave neqs "NONE" and wave neqs "FILE" then call picrestart

elseif msg.name eqs "GAIN"
  set l:gain msg.data
  if reg.sp rexists set reg.sp.gain msg.data
  if reg.sps rexists set reg.sps.gain msg.data
  if reg.spt rexists set reg.spt.gain msg.data
  if /play then call picrestart

elseif msg.name eqs "MGAIN"
  if reg.sp rexists set reg.sp.mgain msg.data
  if reg.sps rexists set reg.sps.mgain msg.data
  if mtype rexists and mtype eq -13 and gc.MODE.v neqs "SETUP" then
    warn "SONET gain change currently requires RESTART to take affect"
  endif

elseif msg.name eqs "RFFREQ"
  call updateRfFreq msg.data
elseif msg.name eqs "RFBW"
  call updateRfBw ^msg.data
elseif msg.name eqs "RFGAIN"
  call updateRfGain msg.data
elseif msg.name eqs "RFATTN"
  call updateRfAttn msg.data
elseif msg.name eqs "RFOPTS"
  call updateRfOpts msg.data
elseif msg.name eqs "RFPWR"
  ! read only

elseif msg.name eqs "CHAN"
  sendto/sync sp set.channel msg.data
  set gc.FREQ.value reg.sp.freq*1e-6
  if /tb and /cross then
    calc/type=l reg.thin1.offset msg.data-1 0 max
    calc/type=l reg.thin2.offset msg.data-1 0 max
  endif

elseif msg.name eqs "STATS"
  if reg.sp  rexists set reg.sp.stats msg.data
  if reg.sps rexists set reg.sps.stats msg.data

elseif msg.name eqs "MONM"
  if reg.sp  rexists set reg.sp.monitor msg.data
  if reg.sps rexists set reg.sps.monitor msg.data

elseif msg.name eqs "EXPA"
  if reg.fft rexists set reg.fft.nexp msg.data
  if reg.fftt rexists set reg.fftt.nexp msg.data
  if reg.svi rexists set reg.svi.nexp l:msg.data

elseif msg.name eqs "AFNAME"
  call checkafname

elseif msg.name eqs "DELAY"
  warn "This only takes effect on application restart"

elseif msg.name eqs "DBGACT"
  picd/flags=aflags ^msg.data card gc.DBGOFF.v gc.DBGVAL.v /node=gc.DBGPRT.itemindex /size=gc.DBGRSZ.v

else
  ! the rest need no other action
  ! say "Unhandled message ^msg.name"
endif
return


procedure picspecs

set l:dec  gc.DEC.value
set d:rate gc.RATE.value
set d:freq gc.FREQ.value
set d:gain gc.GAIN.value
set d:psdr gc.PSDR.value
set l:psda gc.PSDA.value
set s:card gc.CARD.value
set s:port gc.PORT.value
set s:monm gc.MONM.value
set l:nfft ^gc.NFFT.value
set l:frame gc.FRAME.value
set s:format gc.FORMAT.value
set d:length gc.LENGTH.value
set s:wave gc.WAVE.value
sedit gc.CLOCK.value clock trim "" "-"
sedit card card "UPCASE"
invoke bpa nxm.sys.lib.Data.getBPA(format)
if bpa lt 0 set bpa -bpa/8
if port eqss "MOD" and gc.MGAIN.show then
  set d:gain gc.MGAIN.value
endif
if /play then
  calc d:dly gc.DELAY.value ^gc.LENGTH.value-.2 min
  if dly neq gc.DELAY.value then warning "Delay limited by buffer length to ^dly sec"
elseif card neqs "NONE"
  set s:wave "NONE"
endif
if /dual then
  set s:port1 ^{port}1
  set s:port2 ^{port}2
else
  set s:port1 ^{port}
  set s:port2 ^{port}
endif
res s:flg "MUXCLK=^clock|^aflags"
if /sdds istrue and gc.VLAN.v gt 0 res s:flg "IPVLAN=100|^flg"
if /tsp or /tb then
  set l:nfs frame
  set l:nfft frame
elseif frame lt 0 then
  set l:nfs -frame
else
  set l:nfs nfft
endif
if "TUNER" subs port or "TBANK" subs port or "CORE" subs port then
  calc drate rate 1e6 * dec /
  if /ratio gt 0 then
    calc drate drate /ratio *
    if RESAMP nsubs flg then 	! includes PRESAMP
      set flg "^flg|RESAMP"
    endif
  endif
  if format eqss "C" and "CORE" nsubs port calc drate drate/2
  calc l:deci dec
else
  calc drate rate 1e6 *
  calc l:deci 1
endif
if /pmfft or /newpsd then
 calc l:skip drate nfs / (psdr*psda) / round 1 max
 calc l:nbskip drate/dec/2 nfs/2 / (psdr*psda) / round 1 max
 calc l:wbskip rate*1e6 frame / (psdr*psda) / round 1 max
else
 calc l:skip drate nfs / psdr / round 1 max
 calc l:nbskip drate/dec/2 nfs/2 / psdr / round 1 max
 calc l:wbskip rate*1e6 frame / psdr / round 1 max
endif
!if /tb gt 0 or /multi gt 1 calc l:skip 1
calc dfreq freq 1e6 *
if "X" subs format calc scale 1e19
if "L" subs format calc scale 2e9
if "I" subs format calc scale 32768
if "B" subs format calc scale 128
if "N" subs format calc scale 8
if "P" subs format calc scale 1
return

procedure picsetup
call picspecs
trap on setuperror y
! handle reset of card before CBUFSZ queries
if nic neqs "NONE" or card eqs "NONE" then
  set l:ctype 5
else
  if /noreset le 0 and clock neqs rclock 
    info "Resetting ^card ... "
    picd/flags=flg reset ^card 
    res rclock clock
  endif
  picd get card "TYPE" ctype
  if /ovsr ge 0 then picd/flags=flg ovsr ^card ,, //ovsr
endif
call setRange
set gc.SCALE.action scale
if /tb or /multi then
  res l:pps 4m
  res l:ntbc gc.NTBC.v
  res l:tbcs gc.TBCS.v
  set gc.CHAN.max ntbc
else
  res l:pps 128k
  res l:ntbc 1
  res l:tbcs -1
endif
if reg.tdlp rexists and /nbp isfalse and /wbp isfalse and /tb le 0 and /multi le 0
  calc xend frame nfft min drate /
  set reg.tdlp.setOuterLimits("X2") xend
endif
calc l:pps nfs*bpa*2*ntbc pps max
if /atl le 0 then
  if /tsp or /tb then 
    calc l:atl nfs*skip
  elseif ctype eq 5 or ctype eq 6 then
    calc l:atl 1M/bpa nfs / round nfs * 	! guess at decent archive transfer length
  elseif /dual then
    picd/port=port1/flags=flg get card "CBUFSZ" ptl
    res l:atl ptl/bpa	! ptl is in bytes
  else
    picd/port=port/flags=flg get card "CBUFSZ" ptl
    res l:atl ptl/bpa	! ptl is in bytes
  endif
endif
res l:ptl atl*bpa	! ptl is in bytes
if gc.APKT.value eqs "ON" then
  set apkt "DET"
elseif gc.APKT.value eqss "SDDS" then
  set apkt gc.APKT.value
  set flg "^flg|UOPT"
  calc l:ptl ptl*1088/1024
else
  set apkt "NOTPRESENT"
endif
if /exact gt 0 then
  switch "EXACT" filesize get
else
  calc filesize drate*length round
endif
if filesAreOk eq 2 and afn eqs "NULL" and wave neqs "NULL" 
  set l:filesAreOk 0	! need new wave after archive
endif
switch "MULTI" l:multi get 1
if /tb gt 0 calc l:multi ntbc 
if filesAreOk and afn eqs "NULL" then
  ! they are still good from last time
elseif wave eqs "FILE" then
  ! they are from last dearchive
elseif nic neqs "NONE" then
  ! there are no ram files for NICs
elseif /dual then
  if ramfile1 rexists erase/warn=off ramfile1 ramfile2
  switch "RAMFILE1" ramfile1 get "^{card}_^{port1}"
  pic/round=ptl/multi=^multi create ramfile1 ^format filesize drate ^wave ^gain ^dfreq
  switch "RAMFILE2" ramfile2 get "^{card}_^{port2}"
  pic/round=ptl/multi=^multi create ramfile2 ^format filesize drate ^wave ^gain ^dfreq
else
  if ramfile rexists erase/warn=off ramfile
  switch "RAMFILE" ramfile get "^{card}_^{port}"
  pic/round=ptl/multi=^multi create ramfile ^format filesize drate ^wave ^gain ^dfreq
endif
if /nbp then
  sedit port tport sub "MODULE" "TUNER"
  res ramfilet "^{card}_^{tport}"
  switch "NBPF" nbpf get "CI"
  pic/round=ptl create ramfilet nbpf filesize/dec/2 drate/dec/2 "NONE"
elseif /wbp then
  sedit port tport sub "TUNER" "MODULE"
  res ramfilet "^{card}_^{tport}"
  set wbpf "SI"
  if "MBITS=-" subs aflags then set wbpf "CI"
  switch "WBPF" wbpf get wbpf
  pic/round=ptl create ramfilet wbpf psdr*frame rate*1e6 "NONE"
elseif /pmfft then
  if "2" subs port then
    set cport "CORE2"
  else
    set cport "CORE1"
  endif
  res ramfilec "^{card}_^{cport}"
  pic/round=ptl create ramfilec "SL" psdr*frame drate "NONE"
endif
if /dual then
  call preparch "RAMFILE1" "ARCHFILE1" ^{AFN}_1 ^AUX1
  call preparch "RAMFILE2" "ARCHFILE2" ^{AFN}_2 ^AUX2
else
  call preparch "RAMFILE" "ARCHFILE" ^{AFN} ^AUX0
endif
if afn neqs "NULL"
  set l:filesAreOk 2
else
  set l:filesAreOk 1
endif

pipe init	! move back to pipe initialization mode
trap on initerror y

if /dual then
  sedit flg sflg "GSUB" "TGO" "TGON" "GSUB" "SGO" "SGON"
  if /play then
    sinkpic/id=sp archfile1 ramfile1{fs=nfs} card deci dfreq gain /mon=_cb1{ps=pps} /archtl=atl /master=sps &
      /tl=1 /port=port1 /flags=flg /skip=skip /replay=0 /tc=cpu /delay=dly /wrap /monitor=monm
    sinkpic/id=sps archfile2 ramfile2{fs=nfs} card deci dfreq gain /mon=_cb2{ps=pps} /archtl=atl /slave &
      /tl=1 /port=port2 /flags=sflg /skip=skip /replay=0 /tc=cpu /delay=dly /wrap /monitor=monm
  else
    sourcepic/id=sp ramfile1{fs=nfs} _cb1{ps=pps} card deci dfreq gain /master=sps &
      /tl=1 /port=port1 /flags=flg /skip=skip /replay=0 /flush /tc=cpu /monitor=monm &
      /arch=archfile1 /archtl=atl /apacket=^apkt /nchn=ntbc /dfreq=tbcs
    sourcepic/id=sps ramfile2{fs=nfs} _cb2{ps=pps} card deci dfreq gain /slave &
      /tl=1 /port=port2 /flags=sflg /skip=skip /replay=0 /flush /tc=cpu /monitor=monm &
      /arch=archfile2 /archtl=atl /apacket=^apkt /nchn=ntbc /dfreq=tbcs
  endif
  if /tsp then 
  elseif /tb and /cross then
    thin/id=thin1 _cb1 _cb1c 0 -1 ntbc
    thin/id=thin2 _cb2 _cb2c 0 -1 ntbc
    fft/id=fft/psd/log _cb1c _cb1f{form=s^ofb} nfft HANN 0 psda _cb2c _cb2f{form=s^ofb} _cbxf{form=c^ofb}
  elseif /tb isfalse then
    fft/id=fft/psd/log _cb1 _cb1f{form=s^ofb} nfft HANN 0 psda _cb2 _cb2f{form=s^ofb} _cbxf{form=c^ofb}
  endif

elseif nic neqs "NONE" then
  if /play then
    sinkice/id=sp archfile ramfile{fs=nfs} _cb{ps=pps} &
      /tl=1 /skip=skip /replay=0 /tc=cpu /wrap /monitor=monm
  else
    sourceice/id=sp "udp:^nic/^gc.ADDR.v:0" _cb{ps=pps} format drate &
      /tl=1 /skip=skip /replay=0 /tc=cpu /frame=nfs /monitor=monm
  endif
  if /tsp isfalse then
    fft/id=fft/psd/log _cb _cbf{form=s^ofb} nfft HANN 0 psda
  endif

elseif card eqs "NONE" then
  if /play then

  else
    sourcefile/id=sp ramfile{fs=nfs} _cb{ps=pps} 0 -1 skip /tl=1 /replay=0 
  endif
  if /tsp isfalse then
    fft/id=fft/psd/log _cb _cbf{form=s^ofb} nfft HANN 0 psda
  endif

else
  if /rtplay then
    if gc.MODE.v eqss "RTP" then
      noop/id=rtp/rt/wrap/tl=32k archfile _arch{ps=4m} /poll=.001
    else
      waveform/id=rtp/rt/tl=32k _arch{ps=4m} format inf wave calc(2,gain/6,**,scale,*) dfreq 0 0 1/drate /poll=.001
    endif
    sinkpic/id=sp _arch ramfile{fs=nfs} card deci dfreq gain /mon=_cb{ps=pps} /archtl=atl /poll=.001 &
      /tl=1 /port=port /flags=^flg|ncclk /skip=skip /replay=0 /flush /tc=cpu /throttle=ondemand
  elseif /play then
    sinkpic/id=sp archfile ramfile{fs=nfs} card deci dfreq gain /mon=_cb{ps=pps} /archtl=atl &
      /tl=1 /port=port /flags=flg /skip=skip /replay=0 /flush /tc=cpu /delay=dly /wrap /monitor=monm
  else
    sourcepic/id=sp ramfile{fs=nfs} _cb{ps=pps} card deci dfreq gain &
      /tl=1 /port=port /flags=flg /skip=skip /replay=0 /flush /tc=cpu /monitor=monm &
      /arch=archfile /archtl=atl /apacket=^apkt /nchn=ntbc /dfreq=tbcs
  endif
  if /tsp or /tb or /multi then
  elseif /pmfft then
    calc d:xsoff -.5*drate 0 test(format,eqss,c) ?:
    calc l:nfsc  nfs nfs/2 test(format,eqss,c) ?:
    calc d:fdelta nfs/drate skip*psda *
    calc l:nexp gc.EXPA.v 1 max
    sourcepic/id=spc ramfilec{fs=nfsc} _cbc{xs=xsoff,xd=drate/nfft,yd=fdelta} card skip*psda 0 0 &
      /tl=1 /port=cport /framedec /flags=RGO|IPORT=^port|NFFT=^nfft|NAVG=^psda|FFTOPTS=(MAG)|^flg /replay=0 /stats=0
    icecore/id=svi/core=c _cbc _cbf "Smooth" frame=nfsc nexp=nexp scale=1/(nfsc*nfsc) /oform=S^ofb
  else
    fft/id=fft/psd/log _cb _cbf{form=s^ofb} nfft HANN 0 psda
  endif
  if /testcore then
    icecore/core=icex/coredev=^card:^port/iform=^format ,,, "User" decimation=dec 
  endif
endif

if /nbp then
  sourcepic/id=spt ramfilet{fs=frame} _cbt{ps=pps} card dec dfreq gain &
    /tl=1 /port=tport /flags=RGO|^flg /skip=nbskip /replay=0 /stats=10 /autors=2
  fft/id=fftt/psd/log _cbt _cbtf{form=s^ofb} frame HANN 0 psda
endif

if /wbp then
  sourcepic/id=spt ramfilet{fs=frame} _cbt{ps=pps} card wbskip 0 0 &
    /tl=1 /port=tport /flags=RGO|^flg /host=n /replay=0 /stats=10 /autors=2
  fft/id=fftt/psd/log _cbt _cbtf{form=s^ofb} frame HANN 0 psda
endif

if /tivo gt 0 then
  res nflags "FLUSH"
  if gc.AOVER.v eqs "APPEND" res nflags "^nflags|APPEND"
  noop/tl=1 _cbf ^{gc.AFNAME.v}_psd{FLAGS=^nflags,DET=1,CFL=cfl}
endif

if /rtppsd neqs "NULL" then
  sinkdg/id=rtppsd/rtp/hostport=^/rtppsd _cbf
endif

if reg.fft rexists set reg.fft.nexp gc.expa.value

label trappedinit
pipe run	! move into pipe run mode
label trappedsetup
trap off
return

label setuperror
say "Got setup error: ^emsg.data"
goto trappedsetup
return

label initerror
say "Got init error: ^emsg.data"
pause 1
goto trappedinit
return

procedure picstart s:replay
if /server gt 0
  message send "RMIF" ,, "ACK" ,, {SCALE=^scale,MODE=^gc.MODE.v}
endif
if reg.sp nrexists then
  set gc.MODE.v "SETUP"
  return
endif
pause 0.25 	! wait for plotters to reconnect
if /sdds then
  set reg.sp.vlan gc.VLAN.v
  set reg.sp.join gc.ADDR.v
  if reg.sps rexists
    set reg.sps.vlan gc.VLAN.v
    set reg.sps.join gc.ADDR.v
  endif
endif
if rcvr neqs "NONE" and card neqs "NONE"
  call updateRfFreq gc.RFFREQ.v
  call updateRfBw  ^gc.RFBW.v
  call updateRfAttn gc.RFATTN.v
  call updateRfGain gc.RFGAIN.v
  call updateRfOpts gc.RFOPTS.v
endif
if gc.MGAIN.show and gc.GAIN.show then
  set reg.sp.MGAIN gc.MGAIN.value
endif
if reg.spt rexists sendto/sync spt set.replay replay
if reg.spc rexists sendto/sync spc set.replay replay
if reg.sp  rexists sendto/sync sp  set.replay replay
call updateFreqMarker
return

procedure picwait l:count
if card eqs "NONE" return
while reg.sp rexists and reg.sp.dmamode eq 0 and count gt 0
  pause 0.1
  set l:count count-1
endwhile
return

procedure picstop 
if reg.sp rexists set reg.sp.replay ABORT
if reg.spt rexists set reg.spt.replay ABORT
if reg.spc rexists set reg.spc.replay ABORT
if reg.rtp rexists reg "FINISH" "RTP"
set l:count 300 ! 30 second timeout
while count gt 0 and reg.sp rexists or reg.spt rexists 
  pause 0.1
  set l:count count-1
  if calc(count,10,mod) eq 0 warning "Waiting for card stop or archive flush"
endwhile
if count le 0 warning "Problem stopping cards or flushing archive"
return

procedure picrestart
set l:filesAreOk 0
if gc.MODE.value neqss "RT" then
  call picspecs
else
  call picstop
  call picsetup
  call picstart "CONT"
endif
if lsystab rexists call picsystem lsystab
return 

procedure setformat s:sfmode
set port gc.PORT.value 
sedit port portc "RANGE" 0 0
if port eqss "PM" then
  sedit port portc "RANGE" 3 3
else
  sedit port portc "RANGE" 0 0
endif
if "MODULE3" subs port set portc "M3"
if "MCORE" subs port set portc "C"
if sfmode eqs "SET"
  set deform.^portc gc.FORMAT.value
elseif portc neqs lportc then
  set gc.FORMAT.value deform.^portc 
endif
set lportc portc
return

procedure setport
set port gc.PORT.value 
call setformat "CHECK"
! check for tuner (non-Module) config widgets
set show test(port,neqss,"MOD")
set gc.FREQ.show show
set gc.DEC.show show
set gc.GAIN.show show
set show 0
! check for module specific features
if /client isfalse and nic eqss "NONE" and card neqs "NONE" then
  picd/port=port/flags=aflags get card "MTYPE" mtype
  picd/port=port/flags=aflags get card "MREV" mrev
  if show isfalse then set show test(mtype,eq,-3,and,test(mrev,eq,9,or,mrev,ge,13)) ! A2Dr9/13+
  if show isfalse then set show test(mtype,eq,-13,and,test(mrev,ge,6)) ! SNTr6+
  if show isfalse then set show test(mtype,eq,-4) ! CXD
endif
set gc.MGAIN.show show
if /play and gc.WAVE.v neqs "NONE" then
  set gc.FREQ.show 1
  set gc.GAIN.show 1
endif
return

procedure setdec
calc l:bw gc.RATE.v*1e3/2 gc.DEC.v /
set gc.DEC.units "~ ^{bw} kHz"
invoke gc.DEC.refresh
return

procedure preparch u:ramtag u:archtag cs:archname u:auxi
set afqual gc.AFQUAL.v
set ^archtag "NULL"
if /play then set ^archtag ^ramtag
set atfn "^{archname}{AUX=^auxi}"
if afn eqs "NULL" return
if "udp:" subs afn or "stp:" subs afn then
 if afqual neqs "" or cfl gt 0 then 
   set ^archtag "^{afn}{CFL=cfl,^afqual}"
 else
   set ^archtag afn
 endif
 set afn "NULL"
 set apkt "ICE"
 return
endif
if /play then
  res ^archtag "^{archname}{AUX=^auxi,^afqual}"
else
  if atfn fexists then
    switch "OVERLAY" ans get gc.AOVER.value
    if ans eqs "ASK" then
      sedit gc.AOVER.items ans "TRIM" "Ask,"
      gc/tmp/wait menu ans "File: ^atfn exists ..." "^ans" "Leave" /tleft
    endif
  else
    set ans "NEW"
  endif
  set l:det ^gc.HDR.item-1
  res nflags ""
  if cfl gt 0 res nflags "^nflags|+FLUSH"
  if ans eqs "APPEND" res nflags "^nflags|+APPEND"
  if ans eqss "LEAVE" then
    set afn "NULL"
    set gc.MODE.value "RTMEM"
  elseif ans eqs "ABORT" then
    set afn "NULL"
    set gc.MODE.value "SETUP"
  else
    if ans eqs "ERASE" erase/verbose atfn
    set ^archtag "^{archname}{AUX=^auxi,DET=^det,CFL=^cfl,FLAGS=^nflags,^afqual}"
  endif
endif
return

procedure picsystem t:systab
if systab "ISNULL" then return
set maxbytes 16T
foreach item inlist "AUX0,AUX1,AUX2"
 if gc contains "^item"
  res itemi gc.^{item}.value
  if systab contains "DISK_^itemi" and systab.DISK_^itemi "NISNULL"
    set gc.^{item}U.value systab.DISK_^{itemi}.used
    calc maxbytes systab.DISK_^{itemi}.FMBY*1e6 maxbytes min
  else
    set gc.^{item}U.value -1
  endif
 endif
endfor
if maxbytes neq 16T
  calc gc.ATCA.v maxbytes drate*bpa /
endif
if /dual then
  calc l:gc.auxu.value gc.aux1u.value gc.aux2u.value max
else
  res l:gc.auxu.value gc.aux0u.value 
endif
if gc.MODE.value eqs "RTARCHIVE" and /play isfalse then
 if gc.AUXU.value gt gc.FULL.value
  set gc.MODE.action "SETUP"
  warning "Disk is ^{gc.AUXU.value}% full.  Stopped archive."
  gc/temp/timeout=2/handle=gcalert alert ,,, "Disk is ^{gc.AUXU.value}% full.  Stopped archive."
 endif
 if afn neqs "NULL" and /client isFalse and afn fexists and file(afn).datasize gt gc.MAXFS.value
  set gc.MODE.action "SETUP"
  warning "Max File Size of ^gc.MAXFS.value bytes reached.  Stopped archive."
  gc/temp/timeout=2/handle=gcalert alert ,,, "Max File Size of ^gc.MAXFS.value bytes reached.  Stopped archive."
 endif
endif
set lsystab systab
return

procedure refreshTivoPlot
if tvfn nrexists then
  set tvfn "^{gc.AFNAME.v}_psd.tmp"
  if /client gt 0 set tvfn "http://^remote/Files/^tvfn"
  message send "TVRP" ,, "OPENFILE" -1 tvfn
endif
message send "TVRP" ,, "UNZOOM" -1
if gc.TIVOM.v eqs "RT" then
  message send "TVRP" ,, "FILE" ,, "REREAD" 
  if gc.TIVOL.v eqs "ALL" then
    message send "TVRP" ,, "PANTW" 0 (0,0)
  else
    set d:tvl ^gc.TIVOL.v
    set gc.TIVOS.v gc.TIME.v
    set d:tvs gc.TIVOS.v 
    message send "TVRP" ,, "PANTW" 0 (tvs,-tvl)
  endif
else
  set d:tvl ^gc.TIVOL.v 
  set d:tvs gc.TIVOS.v 
  message send "TVRP" ,, "PANTW" 0 (tvs,-tvl)
endif
return

procedure updateFreqMarker
if ff nrexists return
if /tivo and port eqss "MODULE" then
 set ff.x 1e6*gc.FREQ.v
endif
set ff.dx 1e6*gc.RATE.v/2/gc.DEC.v
if /marker then
  set ftmp ff.x
  if "TUNER" subs port or "TBANK" subs port then 
    calc ftmp ftmp gc.FREQ.v*1e6 +
    if "S" eqss format then calc ftmp ftmp 0.25*drate -
  endif
  if reg.sp rexists then calc ftmp reg.sp.mfreq ftmp +
  if /freqadj neq -1 then calc ftmp ^/freqadj ftmp +
  if gc.rffreq rexists then calc ftmp gc.rffreq.v*1e6 ftmp +
  set gc.QFREQ.v ftmp*1e-6
endif
return

procedure updateScale
set d:scale gc.SCALE.v
if /nbp isfalse and /wbp isfalse and /tb isfalse and reg.tdlp rexists then
 set reg.tdlp.y1 -scale
 set reg.tdlp.y2 scale
endif
return

procedure updateRfFreq d:rffreq
if rcvr neqs "ICE" then
  hwdriver set ^rcvr F=rffreq
elseif reg.sps rexists then
  picd/flags=aflags/port=port1 set card "RFFREQ" rffreq
  picd/flags=aflags/port=port2 set card "RFFREQ" rffreq
elseif reg.sp rexists then
  picd/flags=aflags/port=port set card "RFFREQ" rffreq
endif
return

procedure updateRfBw d:rfbw
if rcvr neqs "ICE" then
  hwdriver set ^rcvr BW=rfbw
elseif reg.sps rexists then
  picd/flags=aflags/port=port1 set card "RFBW" rfbw
  picd/flags=aflags/port=port2 set card "RFBW" rfbw
elseif reg.sp rexists then
  picd/flags=aflags/port=port set card "RFBW" rfbw
endif
return

procedure updateRfAttn l:rfattn
if rcvr neqs "ICE" then
  hwdriver set ^rcvr ATN=rfattn
elseif reg.sps rexists then
  picd/flags=aflags/port=port1 set card "RFATTN" rfattn
  picd/flags=aflags/port=port2 set card "RFATTN" rfattn
elseif reg.sp rexists then
  picd/flags=aflags/port=port set card "RFATTN" rfattn
  picd/flags=aflags/port=port get card "RFPWR" gc.RFPWR.v
endif
return

procedure updateRfGain l:rfgain
if rcvr neqs "ICE" then
  hwdriver set ^rcvr ATN=rfgain
elseif reg.sps rexists then
  picd/flags=aflags/port=port1 set card "RFGAIN" rfgain
  picd/flags=aflags/port=port2 set card "RFGAIN" rfgain
elseif reg.sp rexists then
  picd/flags=aflags/port=port set card "RFGAIN" rfgain
endif
return

procedure updateRfOpts s:rfopts
set l:rfopti gc.RFOPTS.ii	! need numeric version from getItemIndex()
if rcvr neqs "ICE" then
!  hwdriver set ^rcvr ATN=rfopti
elseif rfopti eq 0 then
  picd/flags=aflags/port=port get card "RFOPTS" s:gc.RFOPTS.value /hex
elseif reg.sps rexists then
  picd/flags=aflags/port=port1 set card "RFOPTS" rfopti
  picd/flags=aflags/port=port2 set card "RFOPTS" rfopti
elseif reg.sp rexists then
  picd/flags=aflags/port=port set card "RFOPTS" rfopti
endif
return

procedure picfstats s:sid
if logfn eqs "OFF" return
pic fstats/p "^logfn" "^sid"
return

procedure picgstats s:sid
if gc.AMODE.v eqs "DISK" and "RXIPGDBG" subs aflags then
  icetc extract "SDDS" alfn snaptc /gap /quiet
  list2/mod/bg snaptc
  plot/bg snaptc /layer={lt="Multi",columns=GAP} y1=0
else
  if logfn eqs "OFF" return
  pic fstats "^logfn" "^sid" /gap
  plot/bg/id=aplot/all ^{logfn}_gstat y1=0 
endif
return

procedure analyze s:atype cs:afile cs:tmpfile
info "Processing ^atype on file ^afile"
if gc.DMOD.v neqs "NONE" and file(afile).format neqss "C" then
  gc/temp/msg=n alert "TEMP" "Demod" "Demod must have Complex input data"
  return
endif
res bfile ramdemod
if gc.DMOD.v eqs "NONE" then
  res bfile afile
elseif gc.DMOD.v eqs "SQUARE" then
  fcalc bfile afile "SQUARE"
elseif gc.DMOD.v eqs "FOURTH" then
  fcalc bfile afile "SQUARE" "SQUARE"
else
  demod afile{fs=0} bfile gc.DMOD.v
endif
if atype eqs "HISTOGRAM"
  histogram/gpr=gc.APGR.v bfile{fs=0} tmpfile -scale +scale 1
  plot/bg/id=aplot/all tmpfile 
elseif atype eqs "BITSTATS"
  iceutil MBTST bfile{fs=0}
elseif atype eqs "LSBIT"
  fcalc/type=l/gpr=gc.APGR.v ^tmpfile bfile{fs=0,fm=83} 0x1 band
  plot/bg/id=aplot/all ^tmpfile y1=-.2 y2=1.2
elseif atype eqs "TD-LINE"
  plot/bg/id=aplot bfile{fs=0}
elseif atype eqs "TD-RASTER"
  plot/bg/id=aplot bfile{fs=gc.FRAME.v}
elseif atype eqs "FD-LINE"
  fft/psd/gpr=gc.APGR.v bfile{fs=0} tmpfile ^gc.AFFT.v navg=-1
  plot/bg/id=aplot tmpfile cm=10log
elseif atype eqs "FD-RASTER"
  fft/psd/gpr=gc.APGR.v bfile{fs=0} tmpfile ^gc.AFFT.v navg=1
  plot/bg/id=aplot tmpfile cm=10log
elseif atype eqs "TD-PHASE"
  plot/bg/id=aplot bfile{fs=0} cm=phase y1=-180 y2=180 /all
endif
return

procedure addToSet t:tab
!TBD table snapset merge tab
foreach item intable tab
  set snapset.^item tab.^item
endfor
return

procedure setRange
calc fscale scale log 10 *
if reg.fdlp rexists then
  if /fixrange gt 0 then
    set reg.fdlp.mp.scale "MAXRANGE"
    set reg.fdlp.mp.maxrange gc.RANGE.v
    invoke reg.fdlp.mp.useRange()
  else
    set reg.fdlp.mp.scale "AUTOMIN|AUTOMAX"
  endif
endif
if reg.fdrp rexists then
  if /fixrange gt 0 then
    set reg.fdrp.mp.scale "MAXZRANGE"
    set reg.fdrp.mp.maxrange gc.RANGE.v
    invoke reg.fdrp.mp.useRange()
  else
    set reg.fdrp.mp.scale "AUTOMIN|AUTOMAX"
  endif
endif
return

procedure checkafname
if gc.AFNAME.v eqs "NONE" or gc.AFNAME.v eqs "NULL" then
  return
elseif /dual then
  set afname "^{gc.AFNAME.v}_1{AUX=^AUX1}"
else
  set afname "^{gc.AFNAME.v}{AUX=^AUX0}"
endif
if afname nfexists then
 ! do nothing
elseif /play then
  status afname xd=xdelta form=fmt
  calc d:rate 1 xdelta / round 1e-6 *
  if rate eq/t ^gc.RATE.v then
  elseif /autoconf then
    set gc.RATE.v ^rate
  else
    warn "Playback file=^afname rate=^rate not equal to config=^gc.RATE.v. See /AUTOCONF."
  endif
  if fmt eqs gc.FORMAT.v then
  elseif /autoconf then
    set gc.FORMAT.v fmt
  else
    warn "Playback file=^afname format=^fmt not equal to config=^gc.FORMAT.v. See /AUTOCONF."
  endif
else ! acquire

endif
return

procedure dumptcdata
  set tc reg.SP.timecode
  set flen file(ramfile).size
  if tc.offset lt 0 return
  if file(ramfile).length lt 1.5 then warn "Ramfile should be >1.5 sec for /CHECKTC"
  calc offset tc.offset-8 flen mod
  if offset+nfft gt flen then
    thin ramfile tmptcdata offset flen
    mergefile ramfile(0:nfft+flen-offset) tmptcdata
  else
    thin ramfile tmptcdata offset +nfft
  endif
  header tmptcdata fs=nfft
  mergefile tmptcdata dumptcdata 
  file open/d/n tag tmptcstat{sr=(OFFS/SD,WSEC/SD,FSEC/SD)}
  set tag.setdata(0,"OFFS") tc.offset
  set tag.setdata(0,"WSEC") tc.wsec
  set tag.setdata(0,"FSEC") tc.fsec
  file close tag
  mergefile tmptcstat dumptcstat 
return

