package nxm.ice.prim;

import nxm.ice.lib.Core;
import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Implements a NOOP function with reformat and decimation

  @author Jeff Schoen
  @version $Id: icenoop.java,v 1.9 2011/05/24 13:21:12 jgs Exp $
*/
public class icenoop extends Primitive implements Chainable {

  private int dec,tl=4096;
  private DataFile hi,ho;
  private Data dbi,dbo;
  private Core core;

  public int open() {

    dec = MA.getL("DEC",1);

    hi = MA.getDataFile ("IN","1000","S#,C#",0);
    hi.open();

    ho = MA.getDataFile ("OUT",hi,0);
    ho.setXDelta(hi.getXDelta()*dec);
    ho.open();

    core = Core.forName("Noop",MA);
    core.setFormats(hi.getFormat(),ho.getFormat());
    core.set("DECIMATION",dec);
    core.open();

    tl = MA.getL("/TL", tl);
    dbi = hi.getDataBuffer(tl); 
    dbo = ho.getDataBuffer(tl);     
    
    return (NORMAL);
  }

  public int process() {
    int n = hi.read(dbi);
    if (n<0) return (FINISH);
    n = core.process (dbi,n, dbo,tl);
    if (n>0) ho.write(dbo,n);
    return (NORMAL);
  }

  public int close() {
    core.close();
    hi.close();
    ho.close();
    return (NORMAL);
  }

  public Object getNextLink() { return core; }
  public Object getPrevLink() { return null; }

}
