package nxm.ice.prim;

import nxm.ice.lib.Core;
import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Exercise the ICE PCI Express Core Functions

  @author Jeff Schoen
  @version $Id: icer2c.java,v 1.9 2011/05/24 13:21:12 jgs Exp $
*/
public class icepcie extends Primitive implements Chainable {

  private int len,tl;
  private DataFile hi,ho;
  private Data dbi,dbo;
  private Core core;

  public int open() {

    hi = MA.getDataFile ("IN","2000","SI",0);
    hi.open();

    ho = MA.getDataFile ("OUT",hi,0);
    ho.setSize(hi.size);
    ho.open();

    int lanes = MA.getL("/LANES",hi.getSubsize());
    int flags = MA.getL("/FLAGS",0);

    core = Core.forName("PCIe",MA);
    core.set("LANES",lanes);
    core.set("FLAGS",flags);
    core.open();

    len = (int)hi.size;
    tl = MA.getL("/TL", len);
    dbi = hi.getDataBuffer(tl); 
    dbo = ho.getDataBuffer(tl);     
    
    return (NORMAL);
  }

  public int process() {
    int n = hi.read(dbi);
    if (n<0) return (FINISH);
    n = core.process (dbi,n, dbo,tl);
    if (n>0) ho.write(dbo,n);
    return (NORMAL);
  }

  public int close() {
    core.close();
    hi.close();
    ho.close();
    return (NORMAL);
  }

  public Object getNextLink() { return core; }
  public Object getPrevLink() { return null; }

}
