package nxm.ice.prim;

import nxm.ice.lib.Core;
import nxm.sys.inc.*;
import nxm.sys.lib.*;

/**
  Implements Real to Complex conversion

  @author Jeff Schoen
  @version $Id: icer2c.java,v 1.9 2011/05/24 13:21:12 jgs Exp $
*/
public class icer2c extends Primitive implements Chainable {

  private int tl=4096;
  private DataFile hi,ho;
  private Data dbi,dbo;
  private Core core;

  public int open() {

    hi = MA.getDataFile ("IN","1000","S#",0);
    hi.open();

    ho = MA.getDataFile ("OUT",hi,0);
    ho.setFormatMode(COMPLEX);
    ho.setXDelta(hi.getXDelta()*2);
    ho.open();

    double freq = MA.getD("FREQ") * ho.getXDelta(); // normalized
    int flags = MA.getL("/FLAGS");

    core = Core.forName("R2C",MA);
    core.set("FREQUENCY",freq);
    core.set("FLAGS",flags);
    core.open();

    tl = MA.getL("/TL", tl);
    byte dtype = INT;
    dbi = hi.getDataBuffer(tl,dtype); 
    dbo = ho.getDataBuffer(tl,dtype);     
    
    return (NORMAL);
  }

  public int process() {
    int n = hi.read(dbi);
    if (n<0) return (FINISH);
    n = core.process (dbi,n, dbo,tl);
    if (n>0) ho.write(dbo,n);
    return (NORMAL);
  }

  public int close() {
    core.close();
    hi.close();
    ho.close();
    return (NORMAL);
  }

  public Object getNextLink() { return core; }
  public Object getPrevLink() { return null; }

}
