package nxm.ice.prim;

import nxm.sys.inc.*;
import nxm.sys.lib.*;
import nxm.ice.lib.ICEPacket;

/**
  Fan in multichannel packetized data from seperate pipes.

  @author Jeff Schoen
  @version $Id: picfanin.java,v 1.3 2001/04/25 17:08:12 schoenj Exp $
*/
public class picfanin extends Primitive {

  private DataFile hi,his[],ho;
  private int nchan, ichan, lchan;
  private ICEPacket pkt;
  private Data db;
  private boolean renum;

  public int open() {

    nchan = MA.getL("NCHAN");

    String root = MA.getCS("IN");
    his = new DataFile[nchan];
    for (int nc=0; nc<nchan; nc++) {
      hi = new DataFile();
      hi.init(this,root+(nc+1),"1000","S#,C#",0);
      hi.open();
      his[nc]=hi;
    }
    hi = his[0];


    ho = MA.getDataFile("OUT",hi,0);
    ho.open(ho.OUTPUT);
    pkt = (ICEPacket)ho.getPacketHandler();
    if (pkt==null) M.error("Input files are not packetized");

    xfer = MA.getL("/TL",pkt.getFixedSize());
    db = ho.getDataBuffer(xfer);
    renum = MA.getState("/RENUM");
    ichan = 0;

    return (NORMAL);
  }

  public int process() {
    int cn=1;

    // find a channel with data
    for (int i=0; i<nchan; i++) {
      hi = his[ichan]; cn=ichan+1;
      ichan = (++ichan)%nchan;
      if (hi.avail()>0) break;
      if (i==nchan-1) return (NOOP);
    }

    // get the next data buffer
    int n = hi.read(db);
    if (n==0) return (NOOP);
    if (n<0) return (FINISH);

    // transfer packet header
    pkt.copyFrom( (ICEPacket)hi.getPacketHandler() );
    if (renum) pkt.setChannel(cn);

    // copy data to output
    ho.write(db);

    return (NORMAL);
  }

  public int close() {
    for (int nc=0; nc<nchan; nc++) his[nc].close();
    ho.close();
    return (NORMAL);
  }

  public int getChannels() { return nchan; }

}
