

     Building/Compiling the ICE Option Tree for NeXtMidas


ASSUMPTIONS
------------

1.  It is assumed that you have already downloaded and installed the 
X-Midas software, because the ICE software will be installed as an option
tree of X-Midas. 

2.  It is assumed that you have already installed the ICE drivers and libraries 
as instructed in readme.txt.


Installing ICE as an option tree into X-Midas
------------------------------------------------
1. For purposes of these installation instructions, $XMDISK will be used
   to denote the top directory where X-Midas is installed.  ICEROOT is 
   used for these instruction but X-Midas defines XMAREA_ICE once installed
   as an option tree and ICEROOT is not actually needed.

2. Unzip the ICE software in a location of your choosing, usually under 
   $XMDISK/localopts or /midas/opt on UNIX systems to allow the same ICE
   tree to installed under both X-Midas and NeXtMidas.  

     cd /midas/opt
     unzip ice308

3. If you set up a ramdisk when installing the driver on Linux, set the 
   ramdisk Start/Size in the $XMDISK/xm/cfg/diskunx.cfg.  Add the entry:

      /midas/icedisk/  RAM  /dev/mem  500M  512M

   where the 1st parameter after /dev/mem is the Start, the next is Size.
   Be sure you have created the /midas/icedisk/ disk directory for header info.
   
4. Copy ICEROOT/cfg/sample.xmstartup.txt to ~/xmstartup.txt and modify it
   to match your system configuration.  Make sure the 'xmopt ice <path>'
   entry points to the top of the ice tree, /midas/opt/ice308 in this 
   example.  Then start xmidas and enter the shell. 

     > xmstart
     > xm

   Build the startup macro with the ICE setup and run it.

     X-Midas> xmbld %xmstartup
     X-Midas> %xmstartup
   
5. Edit the ICE hardware config file to match the cards that you have
   installed in your machine or use the default one in the ICE tree.
   The sample.xmstartup.txt script points HWFILE to the ICE tree.
   This line will normally be placed in the xmstartup.txt.

     X-Midas> fname hwfile hwconfig ,, ice

6.  Use X-Midas to compile the ICE primitives:
 
     X-Midas> nm
     X-Midas> xmbopt ice

7. Test your install:

     X-Midas> pic test pic1
     X-Midas> pic pfat pic1

8. Run a simple acquisition macro:

     X-Midas> snapper pic1

